var Cookie = {};
Cookie.get = function(sName, sDefaultValue) {
	var sRE = "(?:; |^)" + sName + "=([^;]*);?";
	var oRE = new RegExp(sRE);
	if (oRE.test(document.cookie)) {
		return unescape(RegExp["$1"]);
	} else {
		return sDefaultValue || null;
	}
};
Cookie.set = function(sName, sValue, iExpireSec, sDomain, sPath, bSecure) {
	if (!sName) {
		return;
	}
	if (!sValue) {
		sValue = "";
	}
	var str = sName + "=" + escape(sValue) + "; ";
	if (!isNaN(iExpireSec)) {
		var oDate = new Date();
		oDate.setTime(oDate.getTime() + iExpireSec * 1000);
		str += "expires=" + oDate.toGMTString() + "; ";
	}
	if (sDomain) {
		str += "domain=" + sDomain + "; ";
	}
	if (sPath) {
		str += "path=" + sPath + "; ";
	} else {
		str += "path=/; ";
	} if (bSecure) {
		str += "secure";
	}
	document.cookie = str;
};
Cookie.clear = function(sName) {
	Cookie.set(sName, "", new Date(0));
};

var Util = {};
//外网接口
//Util.WcfUrl = 'http://182.254.139.238:1596/XmjApp.svc/';
Util.WcfUrl = 'http://182.254.139.238:7003/XmjApp.svc/';

//本地接口
//Util.WcfUrl = 'http://192.168.2.115:7009/XmjApp.svc/';
Util.ImgCdn = 'http://admin.xiaomeij.com';
//Util.upUrl = 'http://192.168.2.115:8015';
Util.upUrl = 'http://www.xiaomeij.com';
Util.DiyUrl = 'http://182.254.139.238:9001';

Util.Interface = {};

Util.Interface['找回密码3'] = {
	Url: 'ResetPwdStep3',
	params: function(data) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: data
		}
	}
}

Util.Interface['找回密码2'] = {
	Url: 'ResetPwdStep2',
	params: function(data) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: data
		}
	}
}

Util.Interface['找回密码1'] = {
	Url: 'ResetPwdStep1',
	params: function(data) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: data
		}
	}
}

Util.Interface['修改新手机'] = {
	Url: 'Modify_Phone',
	params: function(data) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: data
		}
	}
}

Util.Interface['新手机短信验证'] = {
	Url: 'checkUsersAccuExist',
	params: function(data) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: data
		}
	}
}

Util.Interface['首页幻灯片'] = {
	Url: 'GetIndexBanner',
	params: function() {
		return {
			method: 'GET',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['幻灯片'] = {
	Url: 'GetIndexFlash',
	params: function(cid) {
		return {
			method: 'GET',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			params: {
				"CategoryID": cid
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['分类产品'] = {
	Url: 'GetCategoryProduct',
	params: function(cid, top) {
		return {
			method: 'GET',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			params: {
				CategoryID: cid
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['二级分类'] = {
	Url: 'GetCategory',
	params: function(cid) {
		return {
			method: 'GET',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			params: {
				CategoryID: cid
			},
			responseType: 'json',
			timeout: 5000
		}
	}
}
Util.Interface['产品详情'] = {
	Url: 'GetProductItem',
	params: function(pid, uid) {
		return {
			method: 'GET',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			params: {
				Pid: pid,
				Uid: uid
			},
			responseType: 'json',
			timeout: 9400 // 10秒请求超时
		}
	}
}
Util.Interface['DIY产品详情'] = {
	Url: 'GetCustomizeItem',
	params: function(pid) {
		return {
			method: 'GET',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			params: {
				Pid: pid
			},
			responseType: 'json',
			timeout: 9400 // 10秒请求超时
		}
	}
}
Util.Interface['加入收藏'] = {
	Url: 'FavorProduct',
	params: function(uid, token, id) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				Uid: uid,
				token: token,
				Pids: id + ''
			}
		}
	}
}
Util.Interface['加入购物车'] = {
	Url: 'AddCart',
	params: function(uid, token, pid, cid, num, skuid) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				Uid: uid,
				token: token,
				Pid: pid,
				CategoryId: cid,
				number: num,
				Skus: skuid + ''
			}
		}
	}
}
Util.Interface['商品评价列表'] = {
	Url: 'GetProCommentList',
	params: function(pid, actions, pageIndex, PageSize) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				Pid: pid,
				actions: actions,
				pageIndex: pageIndex,
				PageSize: PageSize
			}
		}
	}
}
Util.Interface['纸箱DIY计算价格'] = {
	Url: 'ReckonPrice',
	params: function(did, dl, dw, dh, num, pMat) {
		return {
			method: 'GET',
			url: Util.WcfUrl + this.Url,
			params: {
				'id': did,
				'dlength': dl,
				'dwidth': dw,
				'dheight': dh,
				'numbers': num,
				'Product_Material': pMat
			}
		}
	}
}
Util.Interface['收藏商品'] = {
	Url: 'GetFavorDataListModel',
	params: function(uid, token, pageIndex, PageSize, cid) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				Uid: uid,
				token: token,
				pageIndex: pageIndex,
				PageSize: PageSize,
				Cid: cid
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['删除收藏商品'] = {
	Url: 'DelFavorProduct',
	params: function(uid, token, fid) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				'Uid': uid,
				'token': token,
				'Fid': fid
			},
			responseType: 'json'
		}
	}
}
Util.Interface['美豆'] = {
	Url: 'GetPointLogList',
	params: function(uid, token, pageIndex, pageSize) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				'Uid': uid,
				'token': token,
				'pageIndex': pageIndex,
				'PageSize': pageSize
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['用户余额'] = {
	Url: 'GetMoneyLogList',
	params: function(uid, token, pageIndex, pageSize) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"Uid": uid,
				"token": token,
				"pageIndex": pageIndex,
				"PageSize": pageSize
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['优惠券'] = {
	Url: 'GetCouponList',
	params: function(uid, token, pageIndex, pageSize) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"Uid": uid,
				"token": token,
				"pageIndex": pageIndex,
				"PageSize": pageSize
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['订单'] = {
	Url: 'GetOrderList',
	params: function(uid, token, state, pageIndex, pageSize, mark) {

		var data;
		if (mark) {
			data = {
				Uid: uid,
				token: token,
				State: state,
				Mark: mark
			}
		} else {
			data = {
				Uid: uid,
				token: token,
				State: state,
				pageindex: pageIndex,
				pageSize: pageSize
			}
		}


		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: data,
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['会员中心'] = {
	Url: 'GetUserCenterCount',
	params: function(uid, token) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"Uid": uid,
				"token": token
			},
			responseType: 'json'
		}
	}
}
Util.Interface['确认收货'] = {
	Url: 'QueryReceipt',
	params: function(uid, token, oid) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				Uid: uid,
				token: token,
				Oid: oid
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['订单评价数据'] = {
	Url: 'GetOrderComment',
	params: function(uid, token, mark) {
		return {
			method: 'GET',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			params: {
				Uid: uid,
				token: token,
				mark: mark
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}

Util.Interface['会员信息'] = {
	Url: 'Update_UserInfor',
	params: function(data) {

		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: data,
			responseType: 'json'
		}
	}
}

Util.Interface['登录'] = {
	Url: 'CheckLogin',
	params: function(username, password) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"User_Name": username,
				"User_Pass": password
			},
			responseType: 'json'
		}
	}
}
Util.Interface['注册'] = {
	Url: 'RegisterUser',
	params: function(username, md5password, phone) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json',
			},
			data: {
				'User_Name': username,
				'User_Pass': md5password,
				'User_Phone': phone,
			},
			responseType: 'json'
		}
	}
}
Util.Interface['短信'] = {
	Url: 'SendSms',
	params: function(phone) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json',
			},
			data: {
				'Iphone': parseInt(phone),
			},
			responseType: 'json',
		}
	}
}
Util.Interface['热门关键词'] = {
	Url: 'GetSetting',
	params: function() {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"Key": 'Site_Hotword'
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['搜索商品'] = {
	Url: 'GetSearchProduct',
	params: function(searchText, pageIndex, pageSize) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"text": searchText,
				"pageindex": pageIndex,
				"pageSize": pageSize
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['评论'] = {
	Url: 'SubMitComment',
	params: function(uid, token, oid, pid, cid, comments, anonymity, lens) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"Uid": uid,
				"token": token,
				"Oid": oid,
				"Pid": pid,
				"star": parseInt(cid),
				"text": comments,
				"isanonymity": anonymity,
				"imgs": lens ? lens : ''
			},
			responseType: 'json'
		}
	}
}
Util.Interface['修改密码'] = {
	Url: 'ChangePass',
	params: function(uid, token, oldpass, newpass) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"Uid": uid,
				"token": token,
				"OldPass": oldpass,
				"NewPass": newpass
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['支付成功'] = {
	Url: 'PayOrder',
	params: function(uid, token, om, tradeno) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"Uid": uid,
				"token": token,
				"OrderMark": om,
				"trade_no": tradeno
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['支付成功详情'] = {
	Url: 'GetOrderPay',
	params: function(uid, token, oid) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"Uid": uid,
				"token": token,
				"OrderMark": oid,
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['订单支付'] = {
	Url: 'AliPay',
	params: function(uid, token, oid) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"Uid": uid,
				"token": token,
				"OrderMark": oid,
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.Interface['购物车列表'] = {
	Url: 'GetCartList',
	params: function(uid, token, province) {
		return {
			method: 'POST',
			url: Util.WcfUrl + this.Url,
			headers: {
				'Content-Type': 'text/json'
			},
			data: {
				"Uid": uid,
				"token": token,
				"Province": province,
			},
			responseType: 'json',
			timeout: 3000
		}
	}
}
Util.intToData = function(num) { //num形式为：1442910994
	var unixTimestamp = new Date(num * 1000);
	var commonTime = unixTimestamp.toLocaleString()
	return commonTime;
};

Util.DateToInt = function(from) { //日期转换为整形，为20140201形式
	var year = from.getFullYear();
	var mon = (from.getMonth() + 1) < 10 ? ('0' + (from.getMonth() + 1)) : (from.getMonth() + 1);
	var day = from.getDate() < 10 ? ('0' + from.getDate()) : from.getDate();
	var date = year.toString() + mon.toString() + day.toString();
	return date;
};

Util.DateToIntToMin = function(from) { //日期转换为整形（到分钟）from(格式为："2014-02-01 11:30")
	if (from.length != 16)
		return;
	var from = from.split(" ");
	var dateArr = from[0].split("-");
	var minArr = from[1].split(":");
	return ("" + dateArr[0] + dateArr[1] + dateArr[2] + minArr[0] + minArr[1]);
};

Util.formatDate = function(from) { //格式化日期，为2014-02-01形式
	var year = from.getFullYear();
	var mon = (from.getMonth() + 1) < 10 ? ('0' + (from.getMonth() + 1)) : (from.getMonth() + 1);
	var day = from.getDate() < 10 ? ('0' + from.getDate()) : from.getDate();
	var date = year + "-" + mon + "-" + day;
	return date;
};

Util.formatDateToMin = function(from, flag) { //格式化日期(到分钟)，flag：0(201402011130)， flag：1(2014-02-01 11:30形式)
	var year = from.getFullYear();
	var mon = (from.getMonth() + 1) < 10 ? ('0' + (from.getMonth() + 1)) : (from.getMonth() + 1);
	var day = from.getDate() < 10 ? ('0' + from.getDate()) : from.getDate();
	var hour = from.getHours() < 10 ? ('0' + from.getHours()) : from.getHours();
	var min = from.getMinutes() < 10 ? ('0' + from.getMinutes()) : from.getMinutes();

	if (flag == 0)
		var date = year.toString() + mon.toString() + day.toString() + hour.toString() + min.toString();
	else
		var date = year + "-" + mon + "-" + day + " " + hour + ":" + min;
	return date;
};



Util.getUrlPara = function(paraName, sUrl) { /*获取url中的参数值*/
	if (typeof(sUrl) == 'undefined')
		sUrl = document.location.href;
	var urlRegex = new RegExp(paraName + "=[^&]*", "igm");
	var para = sUrl.match(urlRegex);
	if (!para)
		return "";
	var v = para[0];
	from = v.indexOf("=");
	var paraValue = v.substr(from + 1, v.length);
	while (paraValue.indexOf('<') >= 0)
		paraValue = paraValue.replace('<', '');
	if (paraValue.indexOf("#") > 0) {
		from = paraValue.indexOf("#");
		paraValue = paraValue.substr(0, from);
	}
	return paraValue;
};

Util.getByteLength = function(str) {
	return str.replace(/[^\x00-\xff]/g, "**").length;
};

Util.FLOADJS_MAP = {};
Util.FloadJS = function(a, b, d) {
	if (typeof(Util.FLOADJS_MAP[a]) == "undefined") {
		Util.FLOADJS_MAP[a] = 0;
		var c = document.createElement("script"),
			e = document.body || document.getElementsByTagName('head')[0];
		c.onerror = function() {
			if (d !== '' && 'function' == typeof(d)) {
				d();
			}
		};
		if (c.readyState) {
			c.onreadystatechange = function() {
				if (c.readyState == "loaded" || c.readyState == "complete") {
					c.onreadystatechange = null;
					if ('function' == typeof(b)) {
						Util.FLOADJS_MAP[a] = 1;
						b();
					}
				}
			}
		} else {
			c.onload = function() {
				if ('function' == typeof(b)) {
					Util.FLOADJS_MAP[a] = 1;
					b();
				}
			}
		}
		c.src = a;
		e.appendChild(c);
	} else {
		var tc = setInterval(function() {
			if (Util.FLOADJS_MAP[a]) {
				b();
				clearInterval(tc);
			}
		}, 20);
	}
};

Util.encodeHtml = function(s) { /*消除XSS*/
	REGX_HTML_ENCODE = /"|&|'|<|>|[\x00-\x20]|[\x7F-\xFF]|[\u0100-\u2700]/g;
	return (typeof s != "string") ? s : s.replace(REGX_HTML_ENCODE, function($0) {
		var c = $0.charCodeAt(0),
			r = ["&#"];
		c = (c == 0x20) ? 0xA0 : c;
		r.push(c);
		r.push(";");
		return r.join("");
	});
};

Util.transThousandth = function(num) { /*加上千分位*/
	var re = /(-?\d+)(\d{3})/;
	while (re.test(num))
		num = num.replace(re, "$1,$2");
	return num;
};

Util.formatData = function(data, num) { /*将data四舍五入保留num位小数并加上千分位，默认保留2位小数*/
	if ("undefined" == typeof(num) || null == num)
		num = 2;
	return Util.transThousandth((data - 0).toFixed(num));
};

Util.containCC = function(str) { /*字符串str中是否有汉字*/
	if (-1 != escape(str).indexOf("%u"))
		return true;
	return false;
};

Util.isEmail = function(str) { /*是否是合法的email*/
	var reg = /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/;
	return reg.test(str);
};

Util.isPhoneNum = function(str) { /*是否是合法的电话号码*/
	return /^(0[0-9]{2,3}[-]?)?[0-9]{7,8}(-[0-9]{1,8})?$/.test(str) || /^1[3578]{1}[0-9]{9}$/.test(str);
};
Util.isZipCode = function(str) { /*是否是合法的email*/
	var reg = /^[1-9][0-9]{5}$/;
	return reg.test(str);
};

Util.isPositiveInt = function(str) { /*是否是正整数*/
	var reg = /^[0-9]*[1-9][0-9]*$/;
	return reg.test(str);
};

Util.isNum = function(str) { /*是否是数字*/
	var reg = /^[0-9][0-9]*(\.[0-9]+)?$/;
	return reg.test(str);
};

Util.isRate = function(str) { /*是否是小于1的百分数*/
	var reg = /^[0-9]{1,2}%$/;
	return reg.test(str);
};

/*
	divParent: 存放分页控件的div的id
	pageNum: 总的页数
	curPage: 当前是第几页(从0开始)
	ifunction: 点击页码时调用的函数
	maxPageNumber: 一次最多能看到几个页码
*/
Util.perPageNum = 10;
Util.showPageIndex = function(divParent, pageNum, curPage, ifunction, maxPageNumber) {
	if ("function" != typeof(ifunction)) /*ifunction只能是函数指针*/
		return;
	if (!maxPageNumber) /*一次最多能看到几个页码*/
		maxPageNumber = 5;
	maxPageNumber = maxPageNumber - 1;
	if (!divParent || pageNum <= 0 || curPage < 0 || curPage > pageNum - 1 || maxPageNumber < 0)
		return;
	var parentIndex = document.getElementById(divParent);
	if (!parentIndex)
		return;
	var selId = divParent + "PerPageNum";
	var perPageNumCtrl = document.getElementById(selId);
	if (perPageNumCtrl)
		Util.perPageNum = perPageNumCtrl.value;
	var ul = document.createElement("ul");
	/*上一页*/
	var preIndex = document.createElement("li");
	if (0 == curPage)
		preIndex.onclick = function() {
			return false;
		};
	else
		preIndex.onclick = function() {
			ifunction(curPage - 1, Util.perPageNum);
			return false;
		};
	preIndex.innerHTML = "&lt;&lt;";
	preIndex.className = "pre";
	ul.appendChild(preIndex);

	/*中间的页码*/
	var iFrom = 0;
	var iEnd = 0;
	if (maxPageNumber > 0) {
		if (curPage > 0)
			iFrom = curPage - 1;
		iEnd = iFrom + maxPageNumber;
		if (iEnd >= pageNum - 1) {
			iEnd = pageNum - 1;
			iFrom = iEnd - maxPageNumber;
			if (iFrom < 0)
				iFrom = 0;
		}
	} else
		iFrom = iEnd = curPage;
	for (var i = iFrom; i <= iEnd; i++) {
		var idex = document.createElement("li");
		if (i == curPage)
			idex.className = "pagingHover";
		else {
			idex.onclick = function(page) {
				return function() {
					ifunction(page, Util.perPageNum);
					return false;
				};
			}(i);
		}
		idex.innerHTML = i + 1;
		ul.appendChild(idex);
	}

	/*下一页*/
	var nextIndex = document.createElement("li");
	if (pageNum - 1 == curPage)
		nextIndex.onclick = function() {
			return false;
		};
	else
		nextIndex.onclick = function() {
			ifunction(curPage + 1, Util.perPageNum);
			return false;
		};
	nextIndex.innerHTML = "&gt;&gt;";
	nextIndex.className = "next";
	ul.appendChild(nextIndex);

	var div = document.createElement("div");
	div.className = "paging_select";
	var span = document.createElement("span");
	span.innerHTML = "每页显示：";
	var select = document.createElement("select");
	select.id = selId;
	select.options.add(new Option(10, 10, 10 == Util.perPageNum, 10 == Util.perPageNum));
	select.options.add(new Option(20, 20, 20 == Util.perPageNum, 20 == Util.perPageNum));
	select.options.add(new Option(30, 30, 30 == Util.perPageNum, 30 == Util.perPageNum));
	select.onchange = function() {
		Util.showPageIndex(divParent, pageNum, 0, ifunction, maxPageNumber + 1, this.value);
		ifunction(0, Util.perPageNum);
	};
	div.appendChild(span);
	div.appendChild(select);

	parentIndex.innerHTML = "";
	parentIndex.appendChild(ul);
	parentIndex.appendChild(div);
};

String.prototype.replaceAll = function(substr, replacement) { /*字符串替换*/
	return this.replace(new RegExp(substr, "gm"), replacement);
};
String.prototype.trim = function() { /*去除字符串左右的空格*/
	return this.replace(/(^\s*)|(\s*$)/g, "");
};
String.prototype.ltrim = function() { /*去除字符串左边的空格*/
	return this.replace(/(^\s*)/g, "");
};
String.prototype.rtrim = function() { /*去除字符串右边的空格*/
	return this.replace(/(\s*$)/g, "");
};
/*mui代码封装开始*/

//  2015 - 10 - 6  东龙
var packMui = {};

packMui.openWebView = function(id, url, extras) {
	mui.openWindow({
		id: id,
		url: url,
		show: {
			aniShow: 'pop-in'
		},
		waiting: {
			autoShow: false
		},
		extras: extras
	});
}


/**
 *  @description 更具 openWindow 的 extras 来遍历添加功能
 */

packMui.addExtrasFunc = function(view) {
	for (var i in view.cusConfig) {
		if (packMui[i + 'Func'] && typeof packMui[i + 'Func'] === "function") packMui[i + 'Func'](view);
	}
}

/**
 *  @description 比如说有 backId 属性, 那么  packMui.addExtrasFunc 会遍历 extras 的属性  backId + Func 来读取这个属性或者方法是否存在，是否是一个Func 是的话执行
 */

packMui.backIdFunc = function(view) {

	mui.back = function() {
		plus.webview.close(plus.webview.currentWebview());
		mui.fire(plus.webview.getWebviewById(view.cusConfig.backId), 'classifyOpen')
	}
}
/*mui代码封装结束*/
var templates = {};
				getTemplate = function(name, header, content,top) {		
					var template = templates[name];
					if (!template) {
						//预加载共用父模板；
						var headerWebview = mui.preload({
							url: header,
							id: name + "-main",
							styles: {
								popGesture: "hide",
							},
							extras: {
								mType: 'main'
							}
						});
						//预加载共用子webview
						var subWebview = mui.preload({
							url: !content ? "" : content,
							id: name + "-sub",
							styles: {
								top: top,
								bottom: '0px',
							},
							extras: {
								mType: 'sub'
							}
						});
						subWebview.addEventListener('loaded', function() {
							setTimeout(function() {
								subWebview.show();
							}, 50);
						});
						subWebview.hide();
						headerWebview.append(subWebview);
						//iOS平台支持侧滑关闭，父窗体侧滑隐藏后，同时需要隐藏子窗体；
						if (mui.os.ios) { //5+父窗体隐藏，子窗体还可以看到？不符合逻辑吧？
							headerWebview.addEventListener('hide', function() {
								subWebview.hide("none");
							});
						}
						templates[name] = template = {
							name: name,
							header: headerWebview,
							content: subWebview,
						};
					}
					return template;
				};