var app = angular.module('mallApp', ['ngTouch', 'me-lazyload', 'imgurl.filter', 'services']);
app.controller('cartCtrl', function($scope, $http, $window) {
	$scope.btnSwitch = true;
	$scope.emptyCart = true;
	$scope.cartErrow = false;
	
	var LaunchWebview = null,
		detailWebview;
	
	$scope.openProductDetails = function(pid) {
			if (!detailWebview) {
				detailWebview = plus.webview.getWebviewById('examples/commodity/details.html');

				if(detailWebview === null){
					detailWebview = mui.preload({
							url: './commodity/details.html',
							id: 'examples/commodity/details.html',
							styles: {
								top: '0',
								bottom: '0'
							},
						})
				}
			}
			
			mui.fire(detailWebview, 'freshendetail', {
				id: pid
			});
			
			detailWebview.show('pop-in', 200);
		}
	
	mui.plusReady(function() {
				LaunchWebview = plus.webview.getLaunchWebview();
				wss = plus.webview.currentWebview();
				wss.setPullToRefresh({
					support: true,
					height: "50px",
					range: "100px",
					contentdown: {
						caption: "下拉可以刷新"
					},
					contentover: {
						caption: "释放立即刷新"
					},
					contentrefresh: {
						caption: "正在刷新..."
					}
				}, $scope.onRefresh);
			});

		

		$scope.onRefresh = function() {
			setTimeout(function() {
				$scope.initCartList();
				plus.webview.currentWebview().endPullToRefresh();
			}, 500);

		}
	$scope.initCartList = function() {

		localStorage.removeItem('cartId');
		$scope.cartGrounpId = []; // 设置购物车状态 参数
		$scope.cartIds = []; // 删除购物车商品 参数
		$scope.PidsUnique = []; // 收藏购物车商品 参数（有可能含重复Pid情况）
		$scope.allCartId = [];
		$http({
			method: 'POST',
			url: Util.WcfUrl + 'GetCartList',
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				Uid: userInfo.uid(),
				token: userInfo.token(),
				Province: $scope.Province
			},
			timeout: 5000,
		}).success(function(data, status, headers, config) {
			console.log($scope.Province);
			//有时候返回的不是数组 所以会报错
			if(data && data.length){
				mui.fire(LaunchWebview, 'cartSize', {len: data.length});
			}else{
				mui.fire(LaunchWebview, 'cartSize', {len: 0});
			}
			
			$scope.cartList = data;

			
//			console.log(JSON.stringify(data));
			$scope.loading = true;
			if (data) {
				if(data.length == 0){
					$scope.emptyCart = true;
				}else{
				$scope.emptyCart = false;
				$scope.countTotalPrice();
				data.forEach(function(e) {
					$scope.cartGrounpId.push(e.Cart_ID+'-'+e.Cart_IsCheck);
					if(e.Cart_IsCheck == '1'){
						$scope.cartIds.push(e.Cart_ID);
						$scope.PidsUnique.push(e.Product_ID); // 有可能含重复Pid
					}
					$scope.allCartId.push(e.Cart_ID);
				});
				localStorage.setItem('cartId', $scope.cartIds); // 结算使用
				if($scope.cartIds.length == $scope.cartList.length){
					$scope.checkboxAll = true;
				}else{
					$scope.checkboxAll = false;
				}			
				}

			} 
		}).error(function(data, status, headers, config) {
			if(!userInfo.has_login()){
				mui.toast('未登录');
			}else{
				mui.toast('网络超时');
			}
			$scope.cartErrow = true;
		});

	}
	$scope.Province = window.localStorage.getItem('province');
	// 无法获取到地址时，设置默认的『广东省』
	$scope.Province = $scope.Province ? $scope.Province : '广东省';
	$scope.loginNow = function() {
		userInfo.openLogin(plus.webview.currentWebview().id);
	};
	//统计总额
	$scope.countTotalPrice = function(option) {
			$scope.totalPrices = 0;
			for(var i = 0; i <$scope.cartList.length; i++){
				var singlePrice = 0;
				if ($scope.cartList[i].Cart_IsCheck == '1') {
					singlePrice = $scope.cartList[i].Cart_Number * $scope.cartList[i].ProductSku_Price;
					$scope.totalPrices = $scope.totalPrices +singlePrice;
				}
			}
		}
		//SKU修改
	$scope.skuValues = [];
	$scope.skuValuesId = [];
	var times = null;
	$scope.changeCount = function(cartlist, type) {
		if(cartlist.Product_LowestCount && cartlist.UserDivSources_IDS){
			cartlist.Product_LowestCount = cartlist.Product_LowestCount;
		}else{
			cartlist.Product_LowestCount = 1;
		}
		var count = cartlist.Cart_Number;
		$scope.skuValuesFlag = true;
		if (type == 'add') {
			count++;
			if (count > cartlist.ProductSku_Stock) {
				count = cartlist.ProductSku_Stock;
				mui.toast("以超过最大库存");
			}
		} else {
			count--;
			if (count == 0) {
				count = 1;
			}
		}
		if (count < cartlist.Product_LowestCount) {
			count = cartlist.Product_LowestCount;
			mui.toast("不能小于起定量");
		}
		cartlist.Cart_Number = count;
		if ($scope.skuValuesId.length == 0) { //首次修改SKU
			$scope.skuValuesId.push(cartlist.Cart_ID);
			$scope.skuValues.push(cartlist.Cart_ID + '-' + cartlist.Cart_Number);
		} else {
			for (var i = 0; i < $scope.skuValues.length; i++) { //重复cart_id
				if ($scope.skuValuesId[i] == cartlist.Cart_ID) {
					$scope.skuValues.splice(i, 1, cartlist.Cart_ID + '-' + cartlist.Cart_Number);
					$scope.skuValuesId.splice(i, 1, cartlist.Cart_ID);
					$scope.skuValuesFlag = false;
				}
			}
			if ($scope.skuValuesFlag) { //不重复cart_id
				$scope.skuValuesId.push(cartlist.Cart_ID);
				$scope.skuValues.push(cartlist.Cart_ID + '-' + cartlist.Cart_Number);
			}
		}
		console.log($scope.skuValues.join(','));
			clearTimeout(times);  //防止快速点击重复请求，间隔250毫秒，以最后一次请求为准
	    		times = setTimeout(function(){
	    			$scope.tprice();
	    			console.log('发起请求~');
	    		},250);

	};

	// 输入限制
	$scope.cartBlur = function(cartlist) {
			var num = parseInt(cartlist.Cart_Number);
			if (isNaN(num)) {
				cartlist.Cart_Number = cartlist.Product_LowestCount;
			} else {
				if (num > cartlist.ProductSku_Stock) {
					cartlist.Cart_Number = cartlist.ProductSku_Stock;
				} else if (num < cartlist.Product_LowestCount) {
					cartlist.Cart_Number = cartlist.Product_LowestCount;
				} else {
					cartlist.Cart_Number = num;
				}
			}
			console.log(cartlist.Cart_Number);
		}
		// 收藏
		$scope.collect = function(pid){
			console.log(pid);

				$http({
					method: 'POST',
					url: Util.WcfUrl + 'FavorProduct',
					headers: {
						'Content-Type': 'text/json'
					},
					responseType: 'json',
					data: {
						Uid: userInfo.uid(),
						token: userInfo.token(),
						Pids: pid
					},
					timeout: 9000
				}).success(function(data, status, headers, config) {
					if (data) {
						mui.toast('收藏成功！')
					} else {
						mui.toast('已收藏！')
					}
				}).error(function(data, status, headers, config) {
					mui.toast('网络超时或重新登录！')
				});
			}

	//编辑 ，修改购物车
	$scope.edit = function() {
		if (!$scope.cartErrow) {
			$scope.editStatus = !$scope.editStatus;
			if (!$scope.editStatus && $scope.skuValues.join(',') != '') {
				$http({
					method: 'POST',
					url: Util.WcfUrl + 'UpdateCart',
					headers: {
						'Content-Type': 'text/json'
					},
					responseType: 'json',
					data: {
						Uid: userInfo.uid(),
						token: userInfo.token(),
						Values: $scope.skuValues.join(',')
					}
				}).success(function(data, status, headers, config) {
					// 清除选中的组ID
					$scope.Pids = [];
					$scope.cartIds = [];

					$scope.initCartList();

				}).error(function(data, status, headers, config) {

				});
			}
		}
	};
	//删除购物车商品
	$scope.delCartShop = function(txt) {
		var ct =null;
		ct = txt == 'all'? $scope.allCartId.join(',') : $scope.cartIds.join(',');
		if(txt){
			$scope.delFunc(ct);
		}else{
			if ($scope.cartIds.length == 0) {
				mui.toast('请选择商品！');
				$scope.btnSwitch = true;
			} else {
				plus.nativeUI.actionSheet({title:"删除选择的商品？",cancel:"取消",buttons:[{title:"删除",style:"destructive"}]},
						function(e){
							if (e.index == 1) {
								$scope.delFunc(ct);
							}
						})

			}
		}
	}
	$scope.delFunc = function(ct){
		$http({
			method: 'POST',
			url: Util.WcfUrl + 'delCartList',
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				Uid: userInfo.uid(),
				token: userInfo.token(),
				Cids: ct
			}
		}).success(function(data, status, headers, config) {
			$scope.btnSwitch = true;
			mui.toast('删除成功！');
			$scope.initCartList();
		}).error(function(data, status, headers, config) {
			if (!userInfo.token()) {
				mui.toast('请登录后重试！');
				$scope.btnSwitch = true;
			}
		});
	}


	$scope.formData = {};
	// 定义去重复数组方法
	var unique = function(arr) {
		var result = [],
			hash = {};
		for (var i = 0, elem;
			(elem = arr[i]) != null; i++) {
			if (!hash[elem]) {
				result.push(elem);
				hash[elem] = true;
			}
		}
		return result;
	};
	$scope.delAll = function(){
		console.log($scope.cartIds);
	}
	// 选择商品（选中的购物车商品ID：$scope.cartIds,产品ID：$scope.Pids，购物车更新$scope.updataCartId
	mui('#cartCtrl').on('tap', '.ui-checkbox', function() {
		var checkall = document.getElementById('checkbox-cart-all');
		var inputId = this.getAttribute('id');
		var that = this;
		if (inputId == 'checkbox-cart-all') {
			$scope.cartGrounpId = []
			if (that.classList.contains("active")) {
				var clist = mui('.checkbox-list');
				clist.each(function() {
					var ele = this;
					var cids = ele.dataset.cid;
					$scope.cartGrounpId.push(cids + '-0');
				});
			} else {
				var clist = mui('.checkbox-list');
				clist.each(function() {
					var ele = this;
					var cids = ele.dataset.cid;
					$scope.cartGrounpId.push(cids + '-1');
				});
			}
		} else {
			var thisNum = this.dataset.num;
			if (that.classList.contains('active')) {
				$scope.cartGrounpId.splice(thisNum, 1, that.dataset.cid + '-0');
			} else {
				$scope.cartGrounpId.splice(thisNum, 1, that.dataset.cid + '-1');
			}
		}

		$http({
			method: 'POST',
			url: Util.WcfUrl + 'SetCartChecked',
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				Uid: userInfo.uid(),
				token: userInfo.token(),
				Values: $scope.cartGrounpId.join(',')
			}
		}).success(function(data, status, headers, config) {
			console.log(data);
			$scope.initCartList();
		}).error(function(data, type, headers, config) {
			console.log(type);
		});
	}, true);
	$window.addEventListener('classifyOpen', function() {
		console.log('shoppingCart');
		if (userInfo.has_login()) {
			$scope.$apply(function() {
				$scope.initCartList();
			})
		} else {
			$scope.$apply(function() {
				$scope.emptyCart = true;
			});
		}
		
	});
	$window.addEventListener('loginBack', function() {
		console.log('登录成功后返回');
		//		plus.webview.getWebviewById('examples/ucenter/login.html').close();
		$scope.$apply(function() {
			$scope.initCartList();
			$scope.loginStatus = false;
		})

	});
			$scope.tprice = function(){
				$http({
					method: 'POST',
					url: Util.WcfUrl + 'UpdateCart',
					headers: {
						'Content-Type': 'text/json'
					},
					responseType: 'json',
					data: {
						Uid: userInfo.uid(),
						token: userInfo.token(),
						Values: $scope.skuValues.join(',')
					}
				}).success(function(data, status, headers, config) {
					// 清除选中的组ID
					$scope.Pids = [];
					$scope.cartIds = [];

					$scope.initCartList();

				}).error(function(data, status, headers, config) {

				});
			}

})


app.controller('settlementCtrl', function($scope, $rootScope, $http, $window, Xmj) {
	$scope.userInfos = JSON.parse(window.localStorage.getItem('user'));
	$scope.uesrYue = $scope.userInfos.User_Money;
	$scope.initProvince = null;
	console.log($scope.uesrYue);
	if ($scope.uesrYue == 0) {
		$scope.disabledYue = true;
	}
	$scope.validCart = localStorage.getItem('cartId');
	$scope.validCartLength = $scope.validCart.split(',');
	console.log(typeof $scope.validCart);
	// 首次添加地址
	$scope.addNewAddress = function() {
			mui.openWindow({
				url: '/examples/ucenter/addAddress.html',
				id: 'addAddress'
			});
		}
		// 选择收货地址
	$scope.settingAddress = function() {
		mui.openWindow({
			url: '/examples/ucenter/address.html',
			id: 'address.html',
			extras: {
				pageType: 'settlementBack'
			}
		});
	}
	$scope.initAddressList = function() {
		//		User_Money
		$http({
			method: 'POST',
			url: Util.WcfUrl + 'GetUserAddressList',
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				Uid: userInfo.uid(),
				token: userInfo.token(),
				top: 0
			}
		}).success(function(data, status, headers, config) {
			$scope.addressList = data;
			$scope.addressList.area = '';
			$scope.mask = true;
			console.log(JSON.stringify(data));
			for (var i = 0; i < $scope.addressList.length; i++) {
				// 查找是否含有默认地址条目
				//拼接省市区
				if ($scope.addressList[i].UserAddress_IsDefault == 1) {
					$scope.emptyIsDefault = true;
					$scope.addressList.area = area_array[$scope.addressList[i].UserAddress_Province] + sub_array[$scope.addressList[i].UserAddress_Province][$scope.addressList[i].UserAddress_City] + ($scope.addressList[i].UserAddress_District == '0' ? '' : sub_arr[$scope.addressList[i].UserAddress_City][$scope.addressList[i].UserAddress_District]);
					$scope.initProvince = area_array[$scope.addressList[i].UserAddress_Province];
					break;
				}
			}
			$scope.initCartList($scope.initProvince);
		}).error(function(data, status, headers, config) {


		});

	}
	$scope.initAddressList();
	$scope.initCartList = function(pro) {
		$scope.Province = window.localStorage.getItem('province');
		if(pro){
			$scope.Province = pro;
		}else{
			// 无法获取到地址时，设置默认的『广东省』
			$scope.Province = $scope.Province ? $scope.Province : '广东省';
		}
		
		$http({
			method: 'POST',
			url: Util.WcfUrl + 'GetCartList',
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				Uid: userInfo.uid(),
				token: userInfo.token(),
				Province: $scope.Province
			},
			timeout: 5000,
		}).success(function(data, status, headers, config) {
			
			$scope.cartList = data;
			if (data == null) {

			} else {
				var length = $scope.cartList.length;
				$scope.countTotalPrice(length);
			}

		}).error(function(data, status, headers, config) {
				console.log('error--507');

		});
		// 选中cartID
		$scope.filterID = function(e) {
				var lcid = localStorage.getItem('cartId');
				if (lcid.indexOf(e.Cart_ID) != -1) {
					return e;
				}
			}
			//优惠券
		$http({
			method: 'POST',
			url: Util.WcfUrl + 'GetCartCoupon',
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				Uid: userInfo.uid(),
				token: userInfo.token()
			}
		}).success(function(data, status, headers, config) {
			$scope.CouponList = data;
			if(data.length == 0){
				console.log('优惠券为空');
				$scope.isCouponList = true;
			}
		}).error(function(data, status, headers, config) {

		});
	}
	$window.addEventListener('settlementRefresh',function(e){
		var prov = e.detail.province;
		$scope.$apply(function(){
			$scope.initAddressList();
		});
	});
	$scope.CouponMoney = 0;
	$scope.selectCoupon = function(id) {
		console.log($scope.formdata.coupons+'--000---'+JSON.stringify(id));
		for(var i = 0;i<$scope.CouponList.length;i++){
			if($scope.CouponList[i].Coupon_ID == $scope.formdata.coupons){
				$scope.CouponMoney = $scope.CouponList[i].Coupon_Par;
				break;
			}
		}
		console.log($scope.CouponMoney)
	}
	$scope.Province = window.localStorage.getItem('province');
	$scope.countTotalPrice = function(length) {
		$scope.cartList.totalPrice = 0;
		$scope.cartList.totalFreight = 0;
		var lcid = localStorage.getItem('cartId');
		for (var i = 0; i < length; i++) {
			if (lcid.indexOf($scope.cartList[i].Cart_ID) != -1) {
				$scope.cartList.totalPrice += $scope.cartList[i].ProductSku_Price * $scope.cartList[i].Cart_Number;
				$scope.cartList.totalFreight += $scope.cartList[i].Product_Freight * 1;
			}

		}
		$scope.totalPrices = $scope.cartList.totalPrice;
		$scope.totalFreights = $scope.cartList.totalFreight;
	}
	$scope.formdata = {};
	// 显示可用余额
	$scope.isYue = function() {
		$scope.showYue = !$scope.showYue;
		if ($scope.showYue) {
			$scope.formdata.ye = true;
			$scope.t = $scope.totalPrices + $scope.totalFreights - $scope.CouponMoney
			$scope.formdata.yue = $scope.uesrYue > $scope.t?$scope.t:$scope.uesrYue;
			console.log($scope.formdata.ye);

		} else {
			$scope.formdata.ye = false;
			$scope.formdata.yue = '';

		}
		console.log($scope.showYue);
	}
	$scope.yueBlur = function() {
			var num = parseFloat($scope.formdata.yue);
			if (isNaN(num)) {
				$scope.formdata.yue = 0
			} else {
				var  kk = num > $scope.totalPrices + $scope.totalFreights - $scope.CouponMoney ? $scope.totalPrices + $scope.totalFreights - $scope.CouponMoney : num;
				$scope.formdata.yue  = kk.toFixed(2);
			}
		}
		// 是否显示优惠券抵扣
	$scope.isCoupon = function() {
			$scope.showCoupon = !$scope.showCoupon;
			if ($scope.showCoupon) {
				$scope.formdata.yhq = true;
			} else {
				$scope.formdata.yhq = false;
				$scope.formdata.coupons = '';
			}
			console.log($scope.showCoupon);
		}
		//选择发票
	$scope.isFapiao = function() {
		$scope.showFapiao = !$scope.showFapiao;
		if ($scope.showFapiao) {
			$scope.formdata.fp = true;
		} else {
			$scope.formdata.fp = false;
		}
		console.log($scope.showFapiao);
	}

	// 付款
	mui('.cart-bar').on('tap','#payment', function() {
		// 收货地址ID
		if(!$scope.emptyIsDefault){
			mui.toast('请选择添加收货地址！');
			return false;
		}
		$scope.formdata.userAddressID = document.getElementById('userAddressID').value;
		$http({
			method: 'POST',
			url: Util.WcfUrl + 'AddOrder',
			data: {
				Uid: userInfo.uid(),
				token: userInfo.token(),
				Coupon_ID: $scope.formdata.coupons,
				User_Money: $scope.formdata.yue,
				User_Address: $scope.formdata.userAddressID
			},
		}).success(function(data, status, headers, config) {
			console.log(data.length);
			if (data < 0) {
				mui.toast('系统错误');
			} else if (data.length >15 && data.length < 20) {
				localStorage.setItem('cartRefresh',true);
				var oid = data.split('-');
				// 支付成功，打开成功页面
				mui.openWindow({
					url: 'paySuccess.html',
					id: 'paySuccess.html',
					extras: {
							orderId: oid[1]
						}
				});
			} else {
				localStorage.setItem('cartRefresh',true);
				// 支付宝支付
				plus.payment.getChannels(function(s) {
					//	获取支付通道
					$scope.channels = s;
					
					$scope.alipayNow(data);
				}, function(e) {
					alert("获取支付通道列表失败：" + e.message);
					return false;
				});
			}

		}).error(function(data, status, headers, config) {

		});
	});
	// 走支付宝通道
	$scope.alipayNow = function(data) {
		var payFlag = false;
		var payWay;

		if ($scope.channels) {
			for (var i = 0; i < $scope.channels.length; i++) {
				if ($scope.channels[i].id == 'alipay') {
					payFlag = true;
					payWay = i;
					break;
				}
			}
			var payStr = data;
			var prevStr = payStr.indexOf('out_trade_no');
			var nextStr = payStr.indexOf('&partner');
			var OrderMark = payStr.slice(prevStr + 13, nextStr);

			plus.payment.request($scope.channels[payWay], data, function(result) {

//				alert(OrderMark);
				Xmj['获取数据'](Util.Interface['支付成功'].params(userInfo.uid(), userInfo.token(), OrderMark, result.trade_no))
					.then(function(respon) {
						if (respon) {
							// 支付成功，打开成功页面
							mui.openWindow({
								url: 'paySuccess.html',
								id: 'paySuccess.html',
								extras: {
									orderId: OrderMark
								}
							});

						} else {
							//支付失败，返回订单中心
						}

					}).catch(function() {
						console.log('error');
					});
			}, function(e) {
				console.log('---00---'+JSON.stringify(e));
				var orderWebView = plus.webview.getWebviewById('ucenter/myorder.html');
				plus.nativeUI.alert("支付失败，请重试！", null, "支付出错：" + e.code);
					if(orderWebView){
						mui.fire(orderWebView, 'freshen', {
							status: 1,pageType: 'settlement'
						});
						orderWebView.show('pop-in', 150);
					}
			});

		} else {
			alert('没找到支付宝');
		}


		// 确定支付通道ID

	};
	$window.addEventListener('settlementRefresh', function() {
		$scope.initAddressList();
	});
});
app.controller('paySuccessCtrl', function($scope, $http, $window, Xmj) {
	mui.plusReady(function() {
		var self = plus.webview.currentWebview();
		var mid = self.orderId;
		Xmj['获取数据'](Util.Interface['支付成功详情'].params(userInfo.uid(), userInfo.token(), mid))
			.then(function(data) {
				$scope.paylists = data;
				$scope.prices = data.Order_TotalPrice + data.Order_Freight - data.User_Money - data.CouponPrice;
				console.log('----' + JSON.stringify(data));
			}).catch(function() {
				console.log('===error');
			});
	});
});

app.controller('categoryCtrl', function($scope, $http, $window, $timeout,Xmj) {
	$scope.count = 10;
	// 点击二级分类
	$scope.openList = function(ID, e) {
		console.log('点击二级分类')
		tool.notNetworkBack();
		$scope.updateCat(ID);
		$scope.secondId = ID;
		$scope.tabIndex = e;
		var botline = document.getElementById('botLine');
		botline.setAttribute('class', 'active-line active' + e);
		if ($scope.bannerLists) {
			$scope.bannerShow = $scope.bannerLists[e];
		} else {
			$scope.bannerShow = false;
		}
	}
	$scope.updateCat = function(cid, type) {
		document.getElementById('loadingPage').style.display = 'block';
		
		var pageObj = Util.Interface['分类产品'].params(cid);
		Xmj['获取数据'](pageObj)
			.then(function(data) {
				$scope.catelists = data;
				document.getElementById('loadingPage').style.display = 'none';
				document.body.scrollTop = 0;
				$timeout(function(){
					$scope.mask = true;
				},500);
				
			})
	};
	// 二级分类
	$scope.secondCat = function(cid, defaults) {
	document.getElementById('loadingPage').style.display = 'block';
	
		Xmj['获取数据'](Util.Interface['二级分类'].params(cid))
			.then(function(data) {
				$scope.secondCate = data;
				$timeout(function(){
					document.getElementById('item1mobile').classList.add('active');
					document.getElementById('loadingPage').style.display = 'none';
				},300);
				if (!defaults) {
					var defaultId = $scope.secondCate[0].Category_ID;
					$scope.updateCat(defaultId);
					$scope.tabIndex = 0;
					$scope.secondFlash(cid, 0);
				} else {
					var k;
					for (var i = 0; i < $scope.secondCate.length; i++) {
						if ($scope.secondCate[i].Category_ID == defaults) {
							k = i;
							break;
						}
					}
					$scope.updateCat(defaults);
					$scope.secondFlash(cid, k);
					// 默认下标
					var botline = document.getElementById('botLine');
					botline.setAttribute('class', 'active-line active' + k);
					$scope.tabIndex = k;
				}
			}).catch(function() {
				console.log('error');
			});
	};
	
	$scope.showCate = function(id, scid) {
		
			$scope.cateId = id; //切换tab
			$scope.bannerLists = [];
			document.body.scrollTop = 0;
			var pageTitle = document.getElementById('top-title');
			switch (id) {
				case '1':
					pageTitle.innerHTML = '小美包装';
					$scope.showType = true;
					break;
				case '4':
					pageTitle.innerHTML = '小美家居';
					$scope.showType = false;
					break;
				case '10':
					pageTitle.innerHTML = '小美文创';
					$scope.showType = false;
					break;
			}
			$scope.initSecondCate(scid);
			$scope.secondCat(id, scid);
		}
		// 初始化二级分类状态
	$scope.initSecondCate = function(scid) {
			$scope.secondId = scid;
			var botline = document.getElementById('botLine');
			botline.setAttribute('class', 'active-line active0');
		}
		// 二级幻灯片
	$scope.secondFlash = function(id,k) {
		Xmj['获取数据'](Util.Interface['幻灯片'].params(id))
			.then(function(data) {
				$scope.bannerLists = data;
				if ($scope.bannerLists) {
					$scope.bannerShow = data[k];
				} else {
					$scope.bannerShow = false;
				}
			}).catch(function() {

			});
	}
	$window.addEventListener('showCategory', function(event) {
		var scid = event.detail.scid;
		var cid = event.detail.cid;
		$scope.$apply(function() {
			$scope.mask = false;
			$scope.showCate(cid, scid);
			tool.notNetworkBack('back');
		})
	});
	// 滑动切换数据
	$window.addEventListener('swipeleft',function(e){
		var nextID = $scope.tabIndex + 1;
		var detail = e.detail;
		// 滑动距离大于30，且判断当前位置是否最后一个tab
		if(Math.abs(detail.deltaX)>100 && nextID <$scope.secondCate.length){//deltaX=move.x-start.x;
			$scope.openList($scope.secondCate[nextID].Category_ID, nextID);
		}
	});
	// 滑动切换数据
	$window.addEventListener('swiperight',function(e){
		var detail = e.detail;
		var prevID = $scope.tabIndex - 1;
		// 滑动距离大于30，且判断当前位置是否第一个tab
		if(Math.abs(detail.deltaX)>100 && prevID >= 0){//deltaX=move.x-start.x;
			$scope.openList($scope.secondCate[prevID].Category_ID, prevID);
		}
	});

});

app.controller('myorderCtrl', ['$scope', '$http', '$interval', '$window', 'Xmj',
	function($scope, $http, $interval, $window, Xmj) {
		var data;

		var selfView;

		var orderDetailsView,
			detailWebview;

		$scope.loadNum = 10;

		$scope.isloadMore = '';

		$scope.mask = true;
		
		$scope.OrderListIcon = ['&#xe611;','&#xe612;','&#xe613;','&#xe614;'];
		
		$scope.OrderListIconClass = ['icon-xiaomeijiquanbudingdan','icon-xiaomeijiweifukuandingdan','icon-xiaomeijidaishouhuo','icon-xiaomeijipingjiashaidan'];
		
		$scope.imagefiltering = function(imageItem){

			if(imageItem.UserDiySources_IDS === null){

				return Util.ImgCdn + imageItem.Product_Img
				
			}else{

				return Util.DiyUrl + "/WorkImgServer/getImg.ashx?key=" + imageItem.Product_Img  + "&s=150,150";
			}
			return ''
		}
		
		$scope.initData = function() {
			$scope.statusNum = {
				'0': {
					status: -1,
					pageindex: 1,
					addState: false
				},
				'1': {
					status: 0,
					pageindex: 1,
					addState: false
				},
				'2': {
					status: 2,
					pageindex: 1,
					addState: false
				},
				'3': {
					status: 3,
					pageindex: 1,
					addState: false
				}
			}
		}
		$window.addEventListener('freshen', function(ev) {
			Xmj.PlusReady(10).then(function() {
				var pageType = ev.detail.pageType;
				if(pageType == 'settlement'){
					var defaultBtn = document.getElementById('defaultBack');
					var uceterBtn = document.getElementById('backUcenter');
					defaultBtn.style.display = 'none';
					uceterBtn.style.display = 'block';
					mui('.mui-bar').on('tap','#backUcenter',function(){
						mui.fire(plus.webview.getLaunchWebview(),'openCategory');
						plus.webview.getLaunchWebview().show();
					});
					
				}
				if (!userInfo.has_login()) {
					plus.nativeUI.toast('请检测网络与是否登录');
					$scope.mask = false;
					mui.back();
				}
				if (!selfView) {
					selfView = plus.webview.currentWebview();
					orderDetailsView =
						mui.preload({
							url: 'orderDetails.html',
							id: 'orderDetails.html',
							waiting: {
								autoShow: false
							}
						});
					orderDetailsView.hide();

					mui.back = function() {
						$scope.$apply(function() {
							$scope.mask = true;
						})

						plus.webview.hide(selfView, 'pop-out', 200)
						mui.fire(plus.webview.getWebviewById('examples/my_sub.html'), 'classifyOpen')
					}
				}
				$scope.cateId = ev.detail.status;
				console.log($scope.cateId);
				document.body.scrollTop = 0;
				data = JSON.parse(localStorage.getItem('user'));

				$scope.initData();
				$scope.allOrders = [];
				$scope.statusNum['0'].addState = true;

				$scope.getOrderListFunc();
				console.log('freshen 结束')
			})

		})
		$window.addEventListener('backFreshen', function(ev) {
			$scope.mask = true;


			$scope.cateId = ev.detail.cateId;
			console.log($scope.cateId);
			document.body.scrollTop = 0;
			$scope.initData();
			$scope.allOrders = [];
			$scope.statusNum['0'].addState = true;

			$scope.getOrderListFunc();
			console.log('backFreshen 执行完毕')
		})


		$scope.showCate = function(id) {
			if ($scope.cateId != id) {

				$scope.mask = true;
				$scope.initData();
				document.body.scrollTop = 0;
				$scope.cateId = id;

				$scope.getOrderListFunc();
				console.log('showCate 结束')
			}

		}


		$scope.getOrderListFunc = function() {
			console.log($scope.cateId+'--当前ID')
			Xmj['获取数据'](Util.Interface['订单'].params(data.User_ID, data.User_TokenStr, $scope.statusNum[$scope.cateId].status, $scope.statusNum[$scope.cateId].pageindex, $scope.loadNum))
				.then(function(data) {
					console.log(JSON.stringify(data));
					if (angular.isArray(data)) {

						(data.length > 0) ? $scope.notAllOrder = false: $scope.notAllOrder = true;

						if ($scope.statusNum['0'].addState) {

							if (angular.isUndefined($scope.allOrders)) {

								$scope.allOrders = [];
							}

							$scope.allOrders = $scope.allOrders.concat(data);
							$scope.isloadMore = ($scope.loadNum * $scope.statusNum[$scope.cateId].pageindex == $scope.allOrders.length) ? 'allOrders' : '';
							$scope.statusNum['0'].addState = false;
						} else {
							$scope.allOrders = data;
							$scope.lens = $scope.allOrders.length;
							$scope.isloadMore = ($scope.loadNum * $scope.statusNum[$scope.cateId].pageindex == $scope.allOrders.length) ? 'allOrders' : '';
						}

						$scope.mask = false;
					} else {
						console.log('error not Array');
						plus.nativeUI.toast('请检测网络');
						mui.back();
					}
				}).catch(function(err) {
					console.log('error catch');
					console.log(err)
					plus.nativeUI.toast('请检测网络');
					mui.back();
				});


		}


		/**
		 * @description 查看订单
		 */

		$scope.checkFunc = function(mark, state) {

			if (!orderDetailsView) {
				orderDetailsView =
					mui.preload({
						url: 'orderDetails.html',
						id: 'orderDetails.html',
						waiting: {
							autoShow: false
						}
					});
				orderDetailsView.hide();
			}

			mui.fire(orderDetailsView, 'freshen', {
				mark: mark,
				state: state,
				cateId: $scope.cateId
			});

			orderDetailsView.show('pop-in', 200);

		}

		/**
		 * @description 取消订单
		 */

		$scope.cancelFunc = function(oid,otype) {
			$http({
				method: 'POST',
				url: Util.WcfUrl + 'OrderCancel',
				headers: {
					'Content-Type': 'text/json'
				},
				responseType: 'json',
				data: {
					User_ID: userInfo.uid(),
					User_Token: userInfo.token(),
					Order_ID:oid,
					O_type:otype
				}
			}).success(function(data, status, headers, config) {
				console.log(JSON.stringify(data));
				if(data == 0){
					plus.nativeUI.toast('取消订单失败！');
				} else if(data == 1){
					plus.nativeUI.toast('取消订单成功！');
					$scope.getOrderListFunc();
				} else if(data == -1){
					plus.nativeUI.toast('用户未登录！');
				} else if(data == -2){
					plus.nativeUI.toast('订单记录不存或状态不存在！');
				} else if(data == -3){
					plus.nativeUI.toast('非法操作！');
				}
				
			}).error(function(data, status, headers, config) {
	
			});
		}

		Xmj['滚动底部']().then(null, null, function(data) {
			if ($scope.isloadMore && !$scope.mask) {
				$scope.statusNum[$scope.cateId].pageindex += 1;
				$scope.statusNum['0'].addState = true;
				$scope.getOrderListFunc();
				console.log('滚动到底部结束')
			}
		})


		$scope.commentFunc = function(mark) {
			mui.openWindow({
				id: 'commentList.html',
				url: 'commentList1.html',
				styles: {
					//							popGesture: 'close'
				},
				extras: {
					mark: mark
				}
			});
		}
		
		//产品详情
		
		$scope.openPro = function(pid) {
			if (!detailWebview) {
				detailWebview = plus.webview.getWebviewById('examples/commodity/details.html');

				if(detailWebview === null){
					detailWebview = mui.preload({
							url: '../commodity/details.html',
							id: 'examples/commodity/details.html',
							styles: {
								top: '0',
								bottom: '0'
							},
						})
				}
			}
			
			mui.fire(detailWebview, 'freshendetail', {
				id: pid
			});
			
			detailWebview.show('pop-in', 200);
		}

		//确定收货

		$scope.sureReceivingFunc = function(oid, index, objName) {
			mui.confirm('注意！请确认收货在点击确定，否则人财两空！', '小美集', ['是', '否'], function(e) {
				if (e.index == 0) {

					Xmj['获取数据'](Util.Interface['确认收货'].params(data.User_ID, data.User_TokenStr, oid))
						.then(function(data) {
							if (data != null) {
								switch (data) {
									case -1:
										plus.nativeUI.toast('系统错误');
										break;
									case 0:
										plus.nativeUI.toast('签收成功');

										$scope[objName].splice(index, 1);

										userInfo.has_Refresh('true');
										break;
									case 1:
										plus.nativeUI.toast('订单已经签收');
										$scope[objName].splice(index, 1);
										userInfo.has_Refresh('true');
										break;
									case 2:
										plus.nativeUI.toast('订单不存在');
										$scope[objName].splice(index, 1);
										userInfo.has_Refresh('true');
										break;
								}
							} else {
								plus.nativeUI.toast('出问题了请稍后尝试');
								console.log(data);
							}
						}).catch(function() {
							console.log('error');
							plus.nativeUI.toast('请检测网络');
						});


				} else {
					console.log('取消确定收货')
				}
			})

		}
		// 立即付款
		mui("body").on('tap','#orderPayNow',function(){
			var omid = this.dataset.oid;
			$http({
				method: 'POST',
				url: Util.WcfUrl + 'AliPay',
				headers: {
					'Content-Type': 'text/json'
				},
				data: {
					Uid: userInfo.uid(),
					token:userInfo.token(),
					OrderMark: omid
				}
			}).success(function(data, status, headers, config) {
				if (data < 0) {
					mui.toast('系统错误');
				} else if (data.length==17) {
					mui.toast('余额支付成功');
					localStorage.setItem('cartRefresh',true);
					var oid = data.split('-');
					// 支付成功，打开成功页面
					mui.openWindow({
						url: '../paySuccess.html',
						id: '../paySuccess.html',
						extras: {
								orderId: oid[1]
							}
					});
				} else {
					mui.toast('支付宝支付');
					localStorage.setItem('cartRefresh',true);
					// 支付宝支付
					plus.payment.getChannels(function(s) {
						//	获取支付通道
						$scope.channels = s;
						$scope.alipayNow(data,omid);
					}, function(e) {
						alert("获取支付通道列表失败：" + e.message);
						return false;
					});
	
				}
			}).error(function(xhr) {
				console.log('xhr'+xhr);
			});
		});
		// 走支付宝通道
	$scope.alipayNow = function(data,omid) {
		var payFlag = false;
		var payWay;

		if ($scope.channels) {
			for (var i = 0; i < $scope.channels.length; i++) {
				if ($scope.channels[i].id == 'alipay') {
					payFlag = true;
					payWay = i;
					break;
				}
			}

			plus.payment.request($scope.channels[payWay], data, function(result) {
				Xmj['获取数据'](Util.Interface['支付成功'].params(userInfo.uid(), userInfo.token(), omid, result.trade_no))
					.then(function(respon) {
						if (respon) {
							// 支付成功，打开成功页面
							mui.openWindow({
								url: '../paySuccess.html',
								id: '../paySuccess.html',
								extras: {
									orderId: omid
								}
							});

						} else {
							//支付失败，返回订单中心
						}

					}).catch(function() {
						console.log('error');
					});
			}, function(e) {
				console.log(e);
				plus.nativeUI.alert("支付失败，请重试！", null, "支付出错：" + e.code);
			});

		} else {
			alert('没找到支付宝');
		}


		// 确定支付通道ID

	};
		// 申请退/换货
	$scope.AddReturnExchangeGoodsModel = function(oid,omark){
		
		mui.openWindow({
			id:'orderReturn',
			url:'orderReturn.html',
			extras:{
		        oId:oid,
		        oMark:omark
		    }
		})
	}
	// 查看售后详情
	$scope.Get_ReturnExchangeGoodsDetail_Model = function(id){
		mui.openWindow({
			id:'orderReturnDetail',
			url:'orderReturnDetail.html',
			extras:{
		        returnId:id
		    }
		})
	}
}
]);

app.controller('orderDetailsCtrl', ['$scope', '$http', '$interval', '$window', 'Xmj',
	function($scope, $http, $interval, $window, Xmj) {

		var selfView,
			mark,
			state,
			cateId,
			userdata,
			detailWebview;
		$scope.paySuccess;

		$scope.mask = true;
	
	$scope.imagefiltering = function(imageItem){

			if(imageItem.UserDiySources_IDS === null){

				return Util.ImgCdn + imageItem.Product_Img
				
			}else{

				return Util.DiyUrl + "/WorkImgServer/getImg.ashx?key=" + imageItem.Product_Img  + "&s=150,150";
			}
			return ''
		}
	
	// 走支付宝通道
	mui('body').on('tap','#alipayMoment',function(){
		var omid = this.dataset.oid;
		$http({
				method: 'POST',
				url: Util.WcfUrl + 'AliPay',
				headers: {
					'Content-Type': 'text/json'
				},
				data: {
					Uid: userInfo.uid(),
					token:userInfo.token(),
					OrderMark: omid
				}
			}).success(function(data, status, headers, config) {
				if (data < 0) {
					mui.toast('系统错误');
				} else if (data.length==17) {
					mui.toast('余额支付成功');
					localStorage.setItem('cartRefresh',true);
					var oid = data.split('-');
					// 支付成功，打开成功页面
					mui.openWindow({
						url: '../paySuccess.html',
						id: '../paySuccess.html',
						extras: {
								orderId: oid[1]
							}
					});
				} else {
					mui.toast('支付宝支付');
					localStorage.setItem('cartRefresh',true);
					// 支付宝支付
					plus.payment.getChannels(function(s) {
						//	获取支付通道
						$scope.channels = s;
						$scope.alipayNow(data,omid);
					}, function(e) {
						alert("获取支付通道列表失败：" + e.message);
						return false;
					});
	
				}
			}).error(function(xhr) {
				console.log('xhr'+xhr);
			});
		

	});
	// 走支付宝通道
	$scope.alipayNow = function(data,omid) {
		var payFlag = false;
		var payWay;

		if ($scope.channels) {
			for (var i = 0; i < $scope.channels.length; i++) {
				if ($scope.channels[i].id == 'alipay') {
					payFlag = true;
					payWay = i;
					break;
				}
			}

			plus.payment.request($scope.channels[payWay], data, function(result) {
				Xmj['获取数据'](Util.Interface['支付成功'].params(userInfo.uid(), userInfo.token(), omid, result.trade_no))
					.then(function(respon) {
						if (respon) {
							// 支付成功，打开成功页面
							mui.openWindow({
								url: '../paySuccess.html',
								id: '../paySuccess.html',
								extras: {
									orderId: omid
								}
							});

						} else {
							//支付失败，返回订单中心
						}

					}).catch(function() {
						console.log('error');
					});
			}, function(e) {
				console.log(e);
				plus.nativeUI.alert("支付失败，请重试！", null, "支付出错：" + e.code);

			});

		} else {
			alert('没找到支付宝');
		}


		// 确定支付通道ID

	};
		$window.addEventListener('freshen', function(ev) {


			if (!userInfo.has_login()) {
				plus.nativeUI.toast('请检测网络与是否登录');
				$scope.mask = false;
				mui.back();
			}

			Xmj.PlusReady(10).then(function() {
				if (!selfView) {
					selfView = plus.webview.currentWebview();
					detailWebview = plus.webview.getWebviewById('examples/commodity/details.html');
					mui.back = function() {

						var myorder = plus.webview.getWebviewById('ucenter/myorder.html');
						mui.fire(myorder, 'backFreshen', {
							cateId: cateId
						})
						plus.webview.hide(selfView, 'pop-out', 200)
						$scope.$apply(function() {
							$scope.mask = true;
						})
					}
				}

				mark = ev.detail.mark;
				state = ev.detail.state;
				cateId = ev.detail.cateId;
				userdata = JSON.parse(localStorage.getItem('user'));

				$scope.orderDetails();
			})


		})



		$scope.orderDetails = function() {

			Xmj['获取数据'](Util.Interface['订单'].params(userdata.User_ID, userdata.User_TokenStr, state, null, null, mark))
				.then(function(data) {
					if (angular.isArray(data)) {
						console.log(JSON.stringify(data));
						$scope.order = data;
						$scope.lens = data[0]['DetailList'].length;
						$scope.username = userdata.User_Name;
						$scope.mask = false;
					} else {
						console.log('error');
						plus.nativeUI.toast('请检测网络');
						mui.back();
					}

				}).catch(function() {
					console.log('error');
					plus.nativeUI.toast('请检测网络');
					mui.back();
				});

		}

		$scope.cancelFunc = function() {
			$http({
				method: 'POST',
				url: Util.WcfUrl + 'OrderCancel',
				headers: {
					'Content-Type': 'text/json'
				},
				responseType: 'json',
				data: {
					User_ID: userInfo.uid(),
					User_Token: userInfo.token(),
					Order_ID:$scope.order[0].Order_ID,
					O_type:$scope.order[0].Order_State
				}
			}).success(function(data, status, headers, config) {
				console.log(JSON.stringify(data));
				if(data == 0){
					plus.nativeUI.toast('取消订单失败！');
				} else if(data == 1){
					plus.nativeUI.toast('取消订单成功！');
					$scope.orderDetails();
				} else if(data == -1){
					plus.nativeUI.toast('用户未登录！');
				} else if(data == -2){
					plus.nativeUI.toast('订单记录不存或状态不存在！');
				} else if(data == -3){
					plus.nativeUI.toast('非法操作！');
				}
				
			}).error(function(data, status, headers, config) {
	
			});
		}

		$scope.commentFunc = function() {

			mui.openWindow({
				id: 'commentList.html',
				url: 'commentList1.html',
				styles: {
					//							popGesture: 'close'
				},
				extras: {
					mark: mark
				}
			});

		}



		$scope.stayPayFunc = function(pid) {
			if (!detailWebview) {
				detailWebview = plus.webview.getWebviewById('examples/commodity/details.html');

				if(detailWebview === null){
					detailWebview = mui.preload({
							url: '../commodity/details.html',
							id: 'examples/commodity/details.html',
							styles: {
								top: '0',
								bottom: '0'
							},
						})
				}
			}
			
			mui.fire(detailWebview, 'freshendetail', {
				id: pid
			});
			
			detailWebview.show('pop-in', 200);
		}

		//确定收货

		$scope.sureReceivingFunc = function(oid) {
			console.log(oid);
			mui.confirm('注意！请确认收货在点击确定，否则人财两空！', '小美集', ['是', '否'], function(e) {
				if (e.index == 0) {

					Xmj['获取数据'](Util.Interface['确认收货'].params(userdata.User_ID, userdata.User_TokenStr, oid))
						.then(function(data) {
							if (data != null) {
								switch (data) {
									case -1:
										plus.nativeUI.toast('系统错误');
										break;
									case 0:
										plus.nativeUI.toast('签收成功');
										$scope.paySuccess = 1;
										userInfo.has_Refresh('true');
										break;
									case 1:
										plus.nativeUI.toast('订单已经签收');
										$scope.paySuccess = 1;
										userInfo.has_Refresh('true');
										break;
									case 2:
										plus.nativeUI.toast('订单不存在');
										$scope.paySuccess = 1;
										userInfo.has_Refresh('true');
										break;
								}
							} else {
								plus.nativeUI.toast('出问题了请稍后尝试');
								console.log(data);
							}
						}).catch(function() {
							console.log('error');
							plus.nativeUI.toast('请检测网络');
						});


				} else {
					console.log('取消确定收货')
				}
			})

		}
	}
]);
app.controller('orderReturnCtrl',function($scope,$http,Xmj){
	mui.plusReady(function() {
		var self = plus.webview.currentWebview();
		$scope.oid = self.oId;
		$scope.omark = self.oMark;
		
	})
	var lens = null;
	var tasks = [];
	$scope.urls = '';
	$scope.galleryImgs = function () {
			console.log("从相册中选择多张图片:");
			plus.gallery.pick(function(e) {
				if (e.files.length > 3) {
					plus.nativeUI.toast('图片数量最多选择3张,请重新选择');
				} else {
					$scope.$apply(function() {
						$scope.urls = [];
					});
					lens = '';
					filesImgLens = e.files.length;
					asycn(e.files, function(f, next) {
						showImg(f, function() {
							next();
						});
					}, function() {
						console.log('ok');
					});
				}
			}, function(e) {
				console.log("取消选择图片");
			}, {
				filter: "image",
				multiple: true
			});
		}
	function showImg(url, cb) {
			console.log(url)
				// 兼容以“file:”开头的情况
			if (0 != url.toString().indexOf("file://")) {
				url = "file://" + url;
			}
			if (!isCon($scope.urls, url)) {

				$scope.$apply(function() {
					$scope.urls.push(url);
					if (filesImgLens == $scope.urls.length) mui.previewImage();
				})

				UploaderImg(url, cb);
			}
		};


		function UploaderImg(url, cb) {


			// 多张接口 AppUploadList
			// 单张接口 UploadOne
			var task = plus.uploader.createUpload(Util.upUrl + '/UploadFile/UploadOne', {
					method: "POST"
				},
				function(t, status) {
					if (status == 200) {

						console.log(JSON.stringify(t)+'----');

						if (JSON.parse(t.responseText)['ret'] != 0) {

							plus.nativeUI.toast('上传失败！' + JSON.parse(t.responseText)['msg']);
							$scope.$apply(function() {
								//上传失败，清除本地现实图片
								$scope.urls.shift();
							})
						} else {
							lens += (JSON.parse(t.responseText)['msg'] + '|')
						}

						$scope.$apply(function() {
							$scope.mask = false;
						})

						if (cb) cb();
					} else {
						console.log('上传失败')
						plus.nativeUI.toast('上传失败');
						$scope.$apply(function() {
							$scope.mask = false;
							//上传失败，清除本地现实图片
							$scope.urls.shift();
						})
					}
				});
			task.addFile(url, {
				key: 'Filedata'
			});


			task.start();
			$scope.$apply(function() {
				$scope.mask = true;
			})

			var tas = {
				path: url,
				intask: task
			};
			tasks.push(tas);
		};
	function asycn(list, cb_exec, cb_end) {
			var each = function(_list, cb) {
				if (_list.length < 1) {
					return cb_end && cb_end();
				}
				cb(_list.shift(), function() {
					each(list, cb);
				});
			}
			each(list, cb_exec);
		};
		function isCon(arr, val) {
			for (var i = 0, len = arr.length; i < len; i++) {
				if (arr[i] == val)
					return true;
			}
			return false;
		};
		$scope.re_service = [
			{id:0,name:'退货'},
			{id:1,name:'换货'}
		]
		$scope.selectService = function(){
			console.log($scope.re_services);
		}
		$scope.saveOrderReturn = function(){
			if($scope.re_services == undefined || $scope.re_services == null){
				plus.nativeUI.toast('请选择服务类型')
				return false;
			}else if(!$scope.re_Remark){
				plus.nativeUI.toast('请输入退/换货理由!')
				return false;
			} 
			$http({
				method: 'POST',
				url: Util.WcfUrl + 'AddReturnExchangeGoodsModel',
				headers: {
					'Content-Type': 'text/json'
				},
				responseType: 'json',
				data: {
					User_ID: userInfo.uid(),
					User_Token: userInfo.token(),
					OrderDetail_ID:$scope.oid,
					Order_Mark:$scope.omark,
					ReturnExchangeGoods_Type: $scope.re_services,
					ReturnExchangeGoods_Remark: $scope.re_Remark,
					ReturnExchangeGoods_Img: lens
				}
			}).success(function(data, status, headers, config) {
				console.log(JSON.stringify(data));
				if(data > 0 ){
					plus.nativeUI.toast('提交成功');
					setTimeout(function() {
							//返回上一级，并刷新
							mui.fire(plus.webview.getWebviewById('ucenter/myorder.html'), 'backFreshen',{cateId: 0});
							mui.back();
						}, 500)
					
				} else if(data == 0){
					plus.nativeUI.toast('提交失败，请检查网络');
					mui.back();
				} else if(data == -2){
					plus.nativeUI.toast('已存在退换货记录');
					mui.back();
				}
				
			}).error(function(data, status, headers, config) {
	
			});
		}
})
app.controller('orderReturnDetailCtrl',function($scope,$http,Xmj){
	mui.plusReady(function() {
		var self = plus.webview.currentWebview();
		var rid = self.returnId;

		$http({
			method: 'POST',
			url: Util.WcfUrl + 'Get_ReturnExchangeGoodsDetail_Model',
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				User_ID: userInfo.uid(),
				User_Token: userInfo.token(),
				ReturnExchangeGoods_ID: rid
			}
		}).success(function(data, status, headers, config) {
			console.log(JSON.stringify(data));
			$scope.detail = data;
		}).error(function(data, status, headers, config) {


		});
	})
	
})
app.controller('commentListCtrl', ['$scope', '$http', '$interval', '$window', 'Xmj',
	function($scope, $http, $interval, $window, Xmj) {

		var self;
		$scope.data;

		var timeoutNum = 3;

		$scope.mask = true;

		Xmj.PlusReady(10).then(function(data) {
			console.log(data);

			if (!userInfo.has_login()) {
				plus.nativeUI.toast('请检测网络与是否登录');
				mui.back();
			}

			$scope.data = JSON.parse(localStorage.getItem('user'));
			self = plus.webview.currentWebview();
			mark = self.mark;

			$scope.getCommentList();
		})

		$scope.getCommentList = function() {

			Xmj['获取数据'](Util.Interface['订单评价数据'].params($scope.data.User_ID, $scope.data.User_TokenStr, mark))
				.then(function(data) {
					if (angular.isArray(data)) {
						$scope.mask = false;
						console.log(data);
						$scope.commentLists = data;

					} else {
						console.log('error');
						plus.nativeUI.toast('请检测网络');
					}
				}).catch(function() {
					console.log('error');
					plus.nativeUI.toast('请检测网络');
				});

		}


		$scope.commentFunc = function(obj) {

			mui.openWindow({
				id: 'comment.html',
				url: 'comment1.html',
				show: {
					aniShow: 'pop-in'
				},
				waiting: {
					autoShow: true
				},
				extras: {
					commentListWebview: plus.webview.currentWebview(),
					comments: obj
				}
			});
		}

		$window.addEventListener('refresh', function(event) {
			console.log('评论成功')
			console.log('更新评论')
			$scope.getCommentList();
			//			$scope.$apply(function() {
			//				console.log('更新评论')
			//				$scope.getCommentList();
			//			})
		})
	}
])


app.controller('collectCtrl', ['$scope', '$http', '$window', '$interval', 'Xmj',
	function($scope, $http, $window, $interval, Xmj) {
		$scope.mask = true;

		$scope.data;
		
		var detailWebview = null;

		$scope.collectListState = {
			pageIndex: 1,
			pageSize: 10,
			start: true
		}


		Xmj.PlusReady(10).then(function() {

			$scope.data = JSON.parse(localStorage.getItem('user'));
			$scope.getcollectListFunc();
		})

		Xmj['滚动底部']().then(null, null, function(data) {
			if ($scope.isMore && !$scope.mask) {
				$scope.collectListState.pageIndex += 1;
				$scope.collectListState.start = false;
				$scope.getcollectListFunc();
			}
		})

		$scope.getcollectListFunc = function() {

			Xmj['获取数据'](Util.Interface['收藏商品'].params($scope.data.User_ID, $scope.data.User_TokenStr, $scope.collectListState.pageIndex, $scope.collectListState.pageSize, 0))
				.then(function(data) {
					if (angular.isArray(data)) {
						if ($scope.collectListState.start) {
							$scope.isMore = $scope.addMore = (data.length == $scope.collectListState.pageSize) ? 1 : 0;
							$scope.collects = data;

						} else {
							$scope.isMore = (data.length == $scope.collectListState.pageSize) ? 1 : 0;
							$scope.collects = $scope.collects.concat(data);
						}
						$scope.mask = false;
					} else {
						console.log('error');
						plus.nativeUI.toast('请检测网络');
						mui.back();
					}
				}).catch(function() {
					console.log('error');
					plus.nativeUI.toast('请检测网络');
					mui.back();
				});
		}

		$scope.deleteCollectFunc = function(fid, $event, $index) {
			$event.stopPropagation();
			var bts=[{title:"确定",style:"destructive"}];
				plus.nativeUI.actionSheet({title:"移除收藏商品",cancel:"取消",buttons:bts},
					function(e){
						if (e.index == 1) {
							Xmj['获取数据'](Util.Interface['删除收藏商品'].params($scope.data.User_ID, $scope.data.User_TokenStr, fid))
								.then(function(data) {
									console.log(data);
									if (data) {
										$scope.collects.splice($index, 1);
										userInfo.has_Refresh('true');
										plus.nativeUI.toast('删除成功');
									} else {
										plus.nativeUI.toast('删除失败');
									}
								}).catch(function() {
									console.log('error');
									plus.nativeUI.toast('请检测网络');
								});

						} else {
							console.log('取消移除商品')
						}
					}
				);
				
		};
	}
]);

app.controller('balanceCtrl', ['$scope', '$http', '$window', '$interval', 'Xmj',
	function($scope, $http, $window, $interval, Xmj) {
		$scope.mask = true;
		var data;
		$scope.balanceListState = {
			pageIndex: 1,
			pageSize: 10,
			start: true
		}

		$scope.balanceInfo = 0;

		Xmj.PlusReady(10).then(function() {
			data = JSON.parse(localStorage.getItem('user'));
			$scope.getBalanceFunc();
		})

		Xmj['滚动底部']().then(null, null, function(data) {
			if ($scope.isMore && !$scope.mask) {
				console.log('滑动到底部')
				$scope.balanceListState.pageIndex += 1;
				$scope.balanceListState.start = false;
				$scope.getBalanceFunc();
			}
		})

		$scope.getBalanceFunc = function() {

			Xmj['获取数据'](Util.Interface['用户余额'].params(data.User_ID, data.User_TokenStr, $scope.balanceListState.pageIndex, $scope.balanceListState.pageSize))
				.then(function(data) {
					
					console.log(data);
					
					if (angular.isArray(data)) {
						
						if ($scope.balanceListState.start) {
							$scope.isMore = $scope.addMore = (data.length == $scope.balanceListState.pageSize) ? 1 : 0;
							$scope.balanceInfo = data;
							
							$scope.balance = data.length > 0?data[0]['User_NowMoney']:0;
						} else {
							$scope.isMore = (data.length == $scope.balanceListState.pageSize) ? 1 : 0;
							$scope.balanceInfo = $scope.balanceInfo.concat(data);
						}
						$scope.mask = false;
					} else {

						console.log('error');
						plus.nativeUI.toast('请检测网络');
						mui.back();

					}
				}).catch(function() {
					console.log('error');
					plus.nativeUI.toast('请检测网络');
//					mui.back();
				});

		}

	}
]);

app.controller('meidouCtrl', ['$scope', '$http', '$window', '$interval', 'Xmj',
	function($scope, $http, $window, $interval, Xmj) {

		$scope.mask = true;
		$scope.meidouListState = {
			pageIndex: 1,
			pageSize: 10,
			start: true
		}

		$scope.meidouTotal = 0;

		Xmj.PlusReady(10).then(function() {

			$scope.data = JSON.parse(localStorage.getItem('user'));
			$scope.getMeidouFunc();
		})

		Xmj['滚动底部']().then(null, null, function(data) {
			if ($scope.isMore && !$scope.mask) {
				console.log('滑动到底部')
				$scope.meidouListState.pageIndex += 1;
				$scope.meidouListState.start = false;
				$scope.getMeidouFunc();
			}
		})


		$scope.getMeidouFunc = function() {
			Xmj['获取数据'](Util.Interface['美豆'].params($scope.data.User_ID, $scope.data.User_TokenStr, $scope.meidouListState.pageIndex, $scope.meidouListState.pageSize))
				.then(function(data) {
					if (angular.isArray(data)) {
						console.log(data);

						if ($scope.meidouListState.start) {
							$scope.isMore = $scope.addMore = (data.length == $scope.meidouListState.pageSize) ? 1 : 0;
							$scope.meidou = data;
							$scope.meidouTotal = data.length>0?data[0]['PointLog_Now']:0;
						} else {
							$scope.isMore = (data.length == $scope.meidouListState.pageSize) ? 1 : 0;
							$scope.meidou = $scope.meidou.concat(data);
						}

						$scope.mask = false;

					} else {
						console.log('error');
						plus.nativeUI.toast('请检测网络');
						mui.back();
					}
				}).catch(function() {
					console.log('error');
					plus.nativeUI.toast('请检测网络');
					mui.back();
				});

		}

	}
]);
app.controller('settingCtrl', ['$scope', '$http', '$window', '$interval', 'Xmj',
	function($scope, $http, $window, $interval, Xmj) {

		var data,
			LaunchWebview;


		$scope.dateFormat = function(date){

			var idate = null;
			if(typeof date != "string"){
				idate = '1970-0-1'
			}else{
				idate = date;
			}
			
			var arrDate = idate.split('-');
			idate = arrDate[0] + '年' + arrDate[1] + '月' + arrDate[2] + '日';
			return idate
		}
		
		$window.addEventListener('freshen', function() {
			
				Xmj.PlusReady(10).then(function() {

					data = JSON.parse(localStorage.getItem('user'));
					console.log(data.User_TokenStr);
					$scope.settingInfo = data;
					
					if($scope.settingInfo.User_Province == 0){
						$scope.formdata.provinceName = '所在城市';
						$scope.formdata.provinceId = 0;
						$scope.formdata.cityId = 0;
						return;
					}
					$scope.formdata.provinceName = area_array[$scope.settingInfo.User_Province];
					$scope.formdata.provinceId = $scope.settingInfo.User_Province;
					if($scope.settingInfo.User_City != 0){
						$scope.formdata.cityName = sub_array[$scope.settingInfo.User_Province][$scope.settingInfo.User_City];
						$scope.formdata.cityId = $scope.settingInfo.User_City;
					}
					
//					$scope.formdata.districtName = ($scope.settingInfo.UserAddress_District == 0 ? '' : sub_arr[$scope.settingInfo.UserAddress_City][$scope.settingInfo.UserAddress_District]);
//					$scope.formdata.districtId = $scope.settingInfo.UserAddress_District;
				})

		});
		
		//修改手机号码
		
		
		$scope.reviseMbState = true;
		
		$scope.changeReviseMb = function(b){
			$scope.reviseMbState = b;
		}
		
		$scope.securePhone = function(phone){
			
			if(!phone){
				return '';
			}else{
				var len = phone.length - 1;
				return phone[0] + phone[1] + phone[2] + '***' + phone[len - 2] + phone[len - 1] + phone[len]
			}
			
		}
		$scope.valiOldPhone = function(){
			
			if($scope.oldPhone == $scope.settingInfo.User_Phone){
				$scope.changeReviseMb(false);
			}else{
				plus.nativeUI.toast('请输入正确的旧手机号码，如果旧手机号码忘记，请联系客服。');
			}
		}
		
		$scope.newPhone = '';
		$scope.newPhoneValiCode = '';
		
		$scope.valiText = '获取验证码';
		
		
		$scope.newPhoneVail = false;
		$scope.newPhoneSubState = false;
		
		$scope.subNewPhome = function(newPhone,newPhoneValiCode){
			if($scope.newPhoneSubState){
				return;
			}
			if (!!!newPhone || !!!newPhone.toString().match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/)) {
				return plus.nativeUI.toast('请输入确定的新手机号码');
			}
			if(!newPhoneValiCode || newPhoneValiCode.length <= 0){
				return plus.nativeUI.toast('请输入确定的验证码');
			}
			$scope.newPhoneSubState = true;
			
			var currentWebview = plus.webview.currentWebview(),
				myWebview = plus.webview.getWebviewById('examples/my_sub.html'),
				LaunchWebview = plus.webview.getLaunchWebview();
			
			Xmj['获取数据'](Util.Interface['修改新手机'].params({
					Phone : newPhone,
					Code : newPhoneValiCode,
					User_ID : $scope.settingInfo.User_ID,
					User_Token : $scope.settingInfo.User_TokenStr
				})).then(function(data) {
					switch(data)
						{
							case -1:
							//用户未登录
							  	plus.nativeUI.toast('登录已经过期，请重新登录');
							  	break;
							case 0:
							//修改成功
								plus.nativeUI.toast('手机号码修改成功');
								plus.nativeUI.toast('修改成功,请重新登录');
								mui.fire(myWebview, 'backQuit');
								mui.fire(LaunchWebview, 'cartSize', {len: 0});
								userInfo.clear();
								currentWebview.hide();
								currentWebview.reload();
							  	break;
							case -2:
							//更新成功
								plus.nativeUI.toast('手机号码已被使用');
										
							  	break;
							case -3:
							//用户已经存在
								plus.nativeUI.toast('验证码错误');
							  	break;
							case -4:
							//用户已经存在
								plus.nativeUI.toast('服务器繁忙，请稍后再试！');
							  	break;
							default:
								plus.nativeUI.toast('出错了');
								console.log('err');
							//情况之外	
						}

						$scope.newPhoneSubState = false;
					}).catch(function(err) {
						console.log(err);
						$scope.newPhoneSubState = false;
							

						plus.nativeUI.toast('修改失败,请重新尝试');
					});
			
		}
		
		$scope.valiNewPhone = function(newPhone){
			if($scope.newPhoneVail){
				return;
			}

			if (!!!newPhone || !!!newPhone.toString().match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/)) {
				return plus.nativeUI.toast('请输入确定的新手机号码');
			}
			
			$scope.newPhoneVail = true;
			$scope.valiText = 60;
			var delay60 = $interval(function(){
				--$scope.valiText;

				if($scope.valiText == 0){
					$interval.cancel(delay60); 
					$scope.valiText = '获取验证码';
					$scope.newPhoneVail = false;
				}
			},1000)
			
			Xmj['获取数据'](Util.Interface['新手机短信验证'].params({
					strData : newPhone,
					User_ID : $scope.settingInfo.User_ID,
					User_Token : $scope.settingInfo.User_TokenStr
				})).then(function(data) {
					switch(data)
						{
							case -1:
							//用户未登录
							  	plus.nativeUI.toast('登录已经过期，请重新登录');
							  	break;
							case 0:
							//修改成功
								plus.nativeUI.toast('请等待信息');
							  	break;
							case 1:
							//更新成功
								plus.nativeUI.toast('手机号码已被使用');
																
							  	break;
							case 2:
							//用户已经存在
								plus.nativeUI.toast('服务器繁忙，请稍等重试。');
							  	break;
							default:
								plus.nativeUI.toast('出错了');
								console.log('err');
							//情况之外	
						}

							if(data != 0){
								$interval.cancel(delay60); 
								$scope.valiText = '获取验证码';
								$scope.newPhoneVail = false; 
							}

					}).catch(function(err) {
						console.log(err);
							$interval.cancel(delay60); 
							$scope.valiText = '获取验证码';
							$scope.newPhoneVail = false;
							

						plus.nativeUI.toast('修改失败,请重新尝试');
					});
		}
		
		/**
		 * 地区选择STATE
		 */
		$scope.addressId == '';
		$scope.formdata = {};
		$scope.Province = area_array;
		$scope.prov = {};
		$scope.City = {};
		$scope.District = {};
		var myType = function(x, y) {
			this.id = x;
			this.name = y;
		}
		for (var i = 0; i < $scope.Province.length; i++) {
			if ($scope.Province[i] != undefined) {
				$scope.prov[i] = new myType(i, $scope.Province[i]);
			}
		}
		// 选择省份2
		$scope.isActive = false;
		$scope.showProvince = true;
		//弹出省份选择框
		$scope.selectArea = function() {
			$scope.isActive = true;
			$scope.showProvince = true;
			$scope.showCity = false;
			$scope.showDistrict = false;
			$scope.formdata.provinceName1 = '';
			$scope.formdata.cityName1 = '';
			$scope.formdata.districtName1 = '';
		}
		$scope.closeAreaPanel = function() {
			$scope.isActive = false;
		}
		$scope.selectP = function(value) {
			if(value.name == '请选择省份'){
				return;
			}
			$scope.showProvince = false;
			$scope.showCity = true;
			$scope.city = sub_array[value.id];
			$scope.City = {};
			$scope.District = {};
			for (var i = 0; i < $scope.city.length; i++) {
				if ($scope.city[i] != undefined) {
					$scope.City[i] = new myType(i, $scope.city[i]);
				}
			}
			//临时性记录和显示id和name
			$scope.formdata.provinceName1 = value.name;
			$scope.formdata.provinceId1 = value.id;
		}
		$scope.selectC = function(value) {
			if(value.name == '请选择'){
				return;
			}
			$scope.isActive = false;
			$scope.showCity = false;
			//不展示District
//			$scope.showDistrict = true;
			
			$scope.District = {};
			$scope.district = sub_arr[value.id];
			$scope.formdata.cityName1 = value.name;
			$scope.formdata.cityId1 = value.id;
			if ($scope.district) {
				for (var i = 0; i < $scope.district.length; i++) {
					if ($scope.district[i] != undefined) {
						$scope.District[i] = new myType(i, $scope.district[i]);
					}
				}
	
			} else { //直辖市 只需要二级
				$scope.isActive = false;
				$scope.formdata.districtName = '';
				$scope.formdata.districtId = '';
	
				// 转移到输入面板
				$scope.formdata.provinceName = $scope.formdata.provinceName1;
				$scope.formdata.provinceId = $scope.formdata.provinceId1;
				$scope.formdata.cityName = $scope.formdata.cityName1;
				$scope.formdata.cityId = $scope.formdata.cityId1;
			}
			console.log('选择城市完毕，不选择D');
			var oldProvinceId = $scope.settingInfo.User_Province,
				oldCityId = $scope.settingInfo.User_City;
			
			//渲染数据
			$scope.formdata.provinceName = $scope.formdata.provinceName1;
			$scope.formdata.provinceId = $scope.formdata.provinceId1;
			$scope.formdata.cityName = $scope.formdata.cityName1;
			$scope.formdata.cityId = $scope.formdata.cityId1;
			$scope.settingInfo.User_Province = $scope.formdata.provinceId1;
			$scope.settingInfo.User_City = $scope.formdata.cityId;
			
			//提交修改
			setUserInfo().then(function(data) {
						switch(data)
						{
							case -1:
							//用户未登录
							  	plus.nativeUI.toast('登录已经过期，请重新登录');
							  	break;
							case 0:
							//更新失败
								plus.nativeUI.toast('登录已经过期，请重新登录');
							  	break;
							case 1:
							//更新成功
								plus.nativeUI.toast('修改成功');
								
								window.localStorage.setItem('user', JSON.stringify($scope.settingInfo));
								
							  	break;
							case 2:
							//用户已经存在
								plus.nativeUI.toast('用户已经存在');
							  	break;
							default:
								plus.nativeUI.toast('出错了');
								console.log('err');
							//情况之外
						}
						if(data != 1){
							
							$scope.settingInfo.User_Province = oldProvinceId;
							$scope.settingInfo.User_City = oldCityId;
							
							if($scope.settingInfo.User_Province == 0){
								$scope.formdata.provinceName = '所在城市';
								$scope.formdata.provinceId = 0;
								$scope.formdata.cityId = 0;
								return;
							}
							$scope.formdata.provinceName = area_array[$scope.settingInfo.User_Province];
							$scope.formdata.provinceId = $scope.settingInfo.User_Province;
							if($scope.settingInfo.User_City != 0){
								$scope.formdata.cityName = sub_array[$scope.settingInfo.User_Province][$scope.settingInfo.User_City];
								$scope.formdata.cityId = $scope.settingInfo.User_City;
							}
						}
					}).catch(function(err) {
						console.log(err);
						plus.nativeUI.toast('修改失败,请重新尝试');
					});
		}
		
		$window.addEventListener('closeSelect', function() {
			
			if($scope.isActive){
				$scope.$apply(function(){
					$scope.isActive = false;
					$scope.showProvince = false;
					$scope.showCity = false;
				})
			}else{
				mui.back('go');
			}
			
			
		})
//		$scope.selectD = function(value) {
//			$scope.isActive = false;
//			$scope.formdata.districtName1 = value.name;
//			$scope.formdata.districtId1 = value.id;
//			// 转移到输入面板
//			$scope.formdata.provinceName = $scope.formdata.provinceName1;
//			$scope.formdata.provinceId = $scope.formdata.provinceId1;
//			$scope.formdata.cityName = $scope.formdata.cityName1;
//			$scope.formdata.cityId = $scope.formdata.cityId1;
//			$scope.formdata.districtName = $scope.formdata.districtName1;
//			$scope.formdata.districtId = $scope.formdata.districtId1;
//		}
	
	
		$scope.formdata.isdefault = 0;
		
		/**
		 * 地区选择END
		 */
		//获取会员信息
		function setUserInfo(){
			return Xmj['获取数据'](Util.Interface['会员信息'].params({
					User_ID : $scope.settingInfo.User_ID,
					User_Token : $scope.settingInfo.User_TokenStr,
					User_Sex : $scope.settingInfo.User_Sex,
					User_Name : $scope.settingInfo.User_Name,
					User_Nick : $scope.settingInfo.User_Nick,
					User_BirthDay : $scope.settingInfo.User_BirthDay,
					User_Province : $scope.settingInfo.User_Province,
					User_City : $scope.settingInfo.User_City
				}))
		}
		
		//设置性别
		$scope.setSex = function(index){
			var oldSex = $scope.settingInfo.User_Sex;
			if($scope.settingInfo.User_Sex != index){
					$scope.settingInfo.User_Sex = index;
					setUserInfo().then(function(data) {
						switch(data)
						{
							case -1:
							//用户未登录
							  	plus.nativeUI.toast('登录已经过期，请重新登录');
							  	break;
							case 0:
							//更新失败
								plus.nativeUI.toast('登录已经过期，请重新登录');
							  	break;
							case 1:
							//更新成功
								plus.nativeUI.toast('修改成功');
								
								window.localStorage.setItem('user', JSON.stringify($scope.settingInfo));
								
							  	break;
							case 2:
							//用户已经存在
								plus.nativeUI.toast('用户已经存在');
							  	break;
							default:
								plus.nativeUI.toast('出错了');
								console.log('err');
							//情况之外
						}
						if(data != 1){
							$scope.settingInfo.User_Sex = oldSex;
						}
					}).catch(function(err) {
						console.log(err);
						plus.nativeUI.toast('修改失败,请重新尝试');
					});
			}
				
		}
		
		
		
		
		
		function format(date){
		    var year=date.getFullYear();
		    var month=date.getMonth()+1;
		    var day=date.getDate();
		    return {
		    	year : year,
		    	month : month,
		    	day : day
		    }
		}

		$scope.setBirthday = function(){
			
			
			var d = format(new Date()),
				max = 100,
				minD=new Date(),
				maxD=new Date(),
				toD =new Date();
			minD.setFullYear(d.year-100,0,1);
			maxD.setFullYear(d.year,d.month,d.day), 
			toDArr = ($scope.settingInfo.User_BirthDay && typeof $scope.settingInfo.User_BirthDay == 'string')?$scope.settingInfo.User_BirthDay.split('-'):'1970-0-1'.split('-');
			
			toD.setFullYear(toDArr[0],toDArr[1],toDArr[2]);
			
			plus.nativeUI.pickDate( function(event){
			
				
				var dd = format(event.date);
				var oldBirthDay = $scope.settingInfo.User_BirthDay;
				
				//先更新数据，在提交数据，错误则回溯到旧数据
					
				
				if(dd != $scope.settingInfo.User_BirthDay){
					
					
						$scope.$apply(function(){
							$scope.settingInfo.User_BirthDay = dd.year + '-' + dd.month + '-' + dd.day;
						})
					
					
						setUserInfo().then(function(data) {
							switch(data)
							{
								case -1:
								//用户未登录
								  	plus.nativeUI.toast('登录已经过期，请重新登录');
								  	break;
								case 0:
								//更新失败
									plus.nativeUI.toast('登录已经过期，请重新登录');
								  	break;
								case 1:
								//更新成功
									plus.nativeUI.toast('修改成功');

									window.localStorage.setItem('user', JSON.stringify($scope.settingInfo));

								  	break;
								case 2:
								//用户已经存在
									plus.nativeUI.toast('用户已经存在');
								  	break;
								default:
									plus.nativeUI.toast('出错了');
									console.log('err');
								//情况之外
							}
							if(data != 1){
								$scope.$apply(function(){
									$scope.settingInfo.User_BirthDay = oldBirthDay;
								})
							}
						}).catch(function(err) {
							console.log(err);
							plus.nativeUI.toast('修改失败,请重新尝试');
						});
					
				}
				
				
			}, function(err){
				plus.nativeUI.toast('取消设置生日');
			}, {title:"请选择您的生日",date:toD,minDate:minD,maxDate:maxD});
		}
		
		$scope.setNick = function(){
			plus.nativeUI.prompt('请输入要修改的昵称', function(event){

				//var index=event.index; // 用户关闭输入对话框点击按钮的索引值
				//var value=event.value; // 用户输入的内容
				var oldUserNick = $scope.settingInfo.User_Nick;
				if(event.index == 0 && event.value.length > 0 && $scope.settingInfo.User_Nick != event.value){
					$scope.$apply(function(){
						$scope.settingInfo.User_Nick = event.value;
					})
					
						setUserInfo().then(function(data) {
							switch(data)
							{
								case -1:
								//用户未登录
								  	plus.nativeUI.toast('登录已经过期，请重新登录');
								  	break;
								case 0:
								//更新失败
									plus.nativeUI.toast('登录已经过期，请重新登录');
								  	break;
								case 1:
								//更新成功
									plus.nativeUI.toast('修改成功');

									window.localStorage.setItem('user', JSON.stringify($scope.settingInfo));

								  	break;
								case 2:
								//用户已经存在
									plus.nativeUI.toast('用户已经存在');
								  	break;
								default:
									plus.nativeUI.toast('出错了');
									console.log('err');
								//情况之外
							}
							if(data != 1){
								$scope.$apply(function(){
									$scope.settingInfo.User_Nick = oldUserNick;
								})
							}
						}).catch(function(err) {
							console.log(err);
							plus.nativeUI.toast('修改失败,请重新尝试');
						});
				}
				
			}, '修改昵称', '', ['确定','取消']);
		}
		
		$scope.setUserName = function(){
			plus.nativeUI.prompt('请输入要修改的用户名,（*修改/绑定新用户名，可作为登录名）', function(event){

				//var index=event.index; // 用户关闭输入对话框点击按钮的索引值
				//var value=event.value; // 用户输入的内容
				
				var oldUserName = $scope.settingInfo.User_Name;
				
				if(event.index == 0 && event.value.length > 0 && $scope.settingInfo.User_Name != event.value){
					$scope.$apply(function(){
						$scope.settingInfo.User_Name = event.value;
					})
					
					setUserInfo().then(function(data) {
							switch(data)
							{
								case -1:
								//用户未登录
								  	plus.nativeUI.toast('登录已经过期，请重新登录');
								  	break;
								case 0:
								//更新失败
									plus.nativeUI.toast('登录已经过期，请重新登录');
								  	break;
								case 1:
								//更新成功
									plus.nativeUI.toast('修改成功');

									window.localStorage.setItem('user', JSON.stringify($scope.settingInfo));

								  	break;
								case 2:
								//用户已经存在
									plus.nativeUI.toast('用户已经存在');
								  	break;
								default:
									plus.nativeUI.toast('出错了');
									console.log('err');
								//情况之外
							}
							if(data != 1){
								$scope.$apply(function(){
									$scope.settingInfo.User_Nick = oldUserName;
								})
							}
						}).catch(function(err) {
							console.log(err);
							plus.nativeUI.toast('修改失败,请重新尝试');
						});
					
				}
				
			}, '修改用户名', '', ['确定','取消']);
		}
		
		$scope.revisePhone = function() {
			plus.nativeUI.alert("请到PC端修改手机号码!", function() {}, "信息提示", "好的");
		}

		$scope.reviseEmail = function(result) {
			if (result) {
				plus.nativeUI.alert("请到PC端修改邮箱!", function() {}, "信息提示", "好的");
			} else {
				plus.nativeUI.alert("请到PC端设置邮箱!", function() {}, "信息提示", "好的");
			}

		}

		$scope.getCaptcha = function(phone) {
			alert(phone);
		}

		$scope.revisepasswordState = true;
		
		$scope.oldPassWord = '';
		$scope.newPassWord = '';

		$scope.revisepasswordFunc = function() {
			$scope.revisepasswordState = false;
			
			console.log($scope.oldPassWord.length)
			console.log($scope.newPassWord.length)

			if ($scope.oldPassWord.length < 7) {
				plus.nativeUI.toast('密码不能小于7位');
				$scope.revisepasswordState = true;
				return;
			}
			
			if($scope.newPassWord.length < 7) {
				plus.nativeUI.toast('密码不能小于7位');
				$scope.revisepasswordState = true;
				return;
			}
			
			var currentWebview = plus.webview.currentWebview(),
				myWebview = plus.webview.getWebviewById('examples/my_sub.html'),
				LaunchWebview = plus.webview.getLaunchWebview();

			Xmj['获取数据'](Util.Interface['修改密码'].params(data.User_ID, data.User_TokenStr, $scope.oldPassWord, $scope.newPassWord))
				.then(function(data) {
					if (data !== null) {
						if (data) {
							plus.nativeUI.toast('修改成功,请重新登录');
							mui.fire(myWebview, 'backQuit');
							mui.fire(LaunchWebview, 'cartSize', {len: 0});
							userInfo.clear();
							currentWebview.hide();
							currentWebview.reload();
							
							
						} else {
							plus.nativeUI.toast('修改失败,请重确定修改信息');
						}
					}
					$scope.revisepasswordState = true;
				}).catch(function() {
					console.log('error');
					plus.nativeUI.toast('修改失败,请重新尝试');
					$scope.revisepasswordState = true;
				});

		}
		
		
	}
]);


app.controller('searchCtrl', ['$scope', '$http', '$window', '$interval', '$timeout', 'Xmj',
	function($scope, $http, $window, $interval, $timeout, Xmj) {
		$scope.searchResultHtml = false;

		$scope.mask = true;
		window.addEventListener('openSearch', function() {
			$scope.$apply(function() {
				$scope.searchResultHtml = false;
				$scope.historyList = true;
				$scope.searchText = '';
				$scope.getHotSearchFunc();
				$scope.getHistory();
				$scope.mask = false;
			});
		});


		$scope.searchText = '';
		var historyText = [];
		var flag = false;
		var HText = [];
		$scope.saveHistory = function(text) {
				historyText = window.localStorage.getItem('search');
				if (historyText) {
					var HText = historyText.split(',');
					for (var i = 0; i < HText.length; i++) {
						// 查找是否已有记录
						if (text === HText[i]) {
							flag = true; // 不保存
							console.log('已有记录');
							break;
						}
					}
					// 保存记录
					if (!flag) {
						HText = HText.concat(text);
						window.localStorage.setItem('search', HText);
						// 设定最大记录数量
						if (HText.length > 10) {
							HText.shift();
							window.localStorage.setItem('search', HText);

						}

					}
				} else { //首次记录history
					historyText = [text];
					window.localStorage.setItem('search', historyText);

				}
			}
			// 获取历史记录
		$scope.getHistory = function() {
			$scope.historyLists = window.localStorage.getItem('search');

			if ($scope.historyLists) {
				$scope.historySearchTexts = $scope.historyLists;
				$scope.historyList = true;
			} else {
				console.log('没有史记录');
				$scope.historyHide = false;
			}
		}

		// 清除历史记录
		$scope.clearHistory = function() {
			window.localStorage.removeItem('search');
			$scope.historySearchTexts = [];
			$scope.historyHide = false;
		}
		$scope.pageIndex = 1; //起始页
		$scope.pageSize = 8; //每页显示个数
		$scope.getSearchFunc = function(searchText) {
			$scope.pageIndex = 1;
			if (!searchText) { //关键字为空
				mui.toast('请输入关键字');
				$scope.searchResultHtml = false;
				console.log($scope.searchResultHtml);
				return;
			}
			$scope.mask = true;

			Xmj['获取数据'](Util.Interface['搜索商品'].params(searchText, 1, $scope.pageSize))
				.then(function(data) {
					$scope.pageIndex += 1;
					$scope.searchText = searchText;
					if (angular.isArray(data)) {
						console.log(data);
						if (data.length > 0) {
							if (data.length < $scope.pageSize) {
								$scope.pageMore = true;
							}
							$scope.hot = 0;
							$scope.history = 0;
							$scope.searchlists = data;
							$scope.emptyKey = false;
							$scope.searchResultHtml = true;
							$scope.saveHistory(searchText);
						} else {
							plus.nativeUI.toast('搜索不到结果');
							$scope.hot = 1;
							$scope.history = 1;
							$scope.searchlists = [];
						}


						$scope.mask = false;


					} else {
						console.log('error');
						plus.nativeUI.toast('请检测网络');
						$scope.mask = false;

					}
				}).catch(function() {
					console.log('error');
					plus.nativeUI.toast('请检测网络');
					$scope.mask = false;
				});


		}

		$scope.getHotSearchFunc = function(type) {
			var data_hotSearch = JSON.parse(plus.storage.getItem('hotSearchText'));
			if (data_hotSearch) {
				console.log('缓存hotSearch');
				$scope.hotSearchTexts = data_hotSearch[0].Value.split(",");
			} else {
				console.log('新加载hotSearch');
				Xmj['获取数据'](Util.Interface['热门关键词'].params())
					.then(function(data) {
						if (angular.isArray(data)) {
							$scope.hot = (data[0].Value && data[0].Value.length != 0);
							$scope.hotSearchTexts = data[0].Value.split(",");
							plus.storage.setItem('hotSearchText', JSON.stringify(data));
						} else {
							console.log('error');
							plus.nativeUI.toast('请检测网络');
						}
						$scope.mask = false;
					}).catch(function() {
						console.log('error');
						plus.nativeUI.toast('请检测网络');
						$scope.mask = false;
					});
			}

		}

		$scope.hotSearchFunc = function(searchText) {
				$scope.getSearchFunc(searchText)
			}
			// 增加键盘确认搜索事件
		document.getElementById("searchInput").addEventListener("keydown", function(e) {
			if (13 == e.keyCode) {
				$scope.getSearchFunc($scope.searchText);
				// 隐藏键盘
				document.getElementById("searchInput").blur();
			}
		}, false);
		// 加载更多
		$scope.pageMore = false;
		$scope.loadMore = function() {

			Xmj['获取数据'](Util.Interface['搜索商品'].params($scope.searchText, $scope.pageIndex, $scope.pageSize))
				.then(function(data) {
					console.log(data);
					$scope.pageIndex += 1;
					angular.forEach(data, function(item) {
							$scope.searchlists.push(item);
							//                                  $timeout(function () {
							//                                      $scope.searchlists.push(item);
							//                                  }, 100); //add timeout
						})
						// 是否以加载完毕所有记录
					var pageLength = data.length;
					pageLength < $scope.pageSize ? $scope.pageMore = true : $scope.pageMore = false;
				}).catch(function() {
					console.log('error');
					plus.nativeUI.toast('请检测网络');

				});

		}

	}
]);

app.controller('couponCtrl', ['$scope', '$http', '$window', '$interval', 'Xmj',
	function($scope, $http, $window, $interval, Xmj) {
		$scope.mask = true;

		$scope.data;

		var selfView;
		
		$scope.nowTime = function(etime){
			var ntime = Math.round(new Date().getTime()/1000);
			
			return etime < ntime
		}

		$scope.couponListState = {
			pageIndex: 1,
			pageSize: 10,
			start: true
		}

		Xmj.PlusReady(10).then(function() {

			$scope.data = JSON.parse(localStorage.getItem('user'));
			$scope.getCouponFunc();
		})

		Xmj['滚动底部']().then(null, null, function(data) {
			if ($scope.isMore && !$scope.mask) {
				$scope.couponListState.pageIndex += 1;
				$scope.couponListState.start = false;
				$scope.getCouponFunc();
			}
		})

		$scope.getCouponFunc = function() {
			Xmj['获取数据'](Util.Interface['优惠券'].params($scope.data.User_ID, $scope.data.User_TokenStr, $scope.couponListState.pageIndex, $scope.couponListState.pageSize))
				.then(function(data) {
					if (angular.isArray(data)) {
						if ($scope.couponListState.start) {
							$scope.isMore = $scope.addMore = (data.length == $scope.couponListState.pageSize) ? 1 : 0;
							$scope.coupons = data;

						} else {
							$scope.isMore = (data.length == $scope.couponListState.pageSize) ? 1 : 0;
							$scope.coupons = $scope.coupons.concat(data);
						}
						$scope.mask = false;
					} else {
						console.log('error');
						plus.nativeUI.toast('请检测网络');
						mui.back();
					}
				}).catch(function() {
					console.log('error');
					plus.nativeUI.toast('请检测网络');
//					mui.back();
				});
		}

	}
]);

app.controller('commentCtrl', ['$scope', '$http', '$interval', '$window', 'Xmj',
	function($scope, $http, $interval, $window, Xmj) {


		var self;
		var comments;
		var commentListWebview;
		var data;
		var filesImgLens;
		var lens = '';
		$scope.mask = false;
		$scope.urls = [];
		var tasks = [];
		$scope.cateId = 5;

		Xmj.PlusReady(10).then(function() {
			if (!userInfo.has_login()) {
				plus.nativeUI.toast('请检测网络与是否登录');
				mui.back();
			}

			data = JSON.parse(localStorage.getItem('user'));
			self = plus.webview.currentWebview();
			comments = self.comments;
			commentListWebview = self.commentListWebview;


			$scope.commentImg = comments.Product_Img;
			pid = comments.Product_ID;
			$scope.galleryImgs = galleryImgs;
		})


		function galleryImgs() {

			console.log("从相册中选择多张图片:");
			plus.gallery.pick(function(e) {

				if (e.files.length > 3) {
					plus.nativeUI.toast('图片数量最多选择3张,请重新选择');
				} else {

					$scope.$apply(function() {
						$scope.urls = [];
					});
					lens = '';

					filesImgLens = e.files.length;

					asycn(e.files, function(f, next) {
						showImg(f, function() {
							next();
						});
					}, function() {
						console.log('ok');
					});

				}


			}, function(e) {
				console.log("取消选择图片");
			}, {
				filter: "image",
				multiple: true
			});
		}

		function showImg(url, cb) {
			console.log(url)
				// 兼容以“file:”开头的情况
			if (0 != url.toString().indexOf("file://")) {
				url = "file://" + url;
			}
			if (!isCon($scope.urls, url)) {

				$scope.$apply(function() {
					$scope.urls.push(url);
					if (filesImgLens == $scope.urls.length) mui.previewImage();
				})

				UploaderImg(url, cb);
			}
		};


		function UploaderImg(url, cb) {


			// 多张接口 AppUploadList
			// 单张接口 UploadOne
			var task = plus.uploader.createUpload(Util.upUrl + '/UploadFile/UploadOne', {
					method: "POST"
				},
				function(t, status) {
					if (status == 200) {

						console.log(t.responseText);

						if (JSON.parse(t.responseText)['ret'] != 0) {

							plus.nativeUI.toast('上传失败！' + JSON.parse(t.responseText)['msg']);
							$scope.$apply(function() {
								//上传失败，清除本地现实图片
								$scope.urls.shift();
							})
						} else {
							lens += (JSON.parse(t.responseText)['msg'] + ',')
						}

						$scope.$apply(function() {
							$scope.mask = false;
						})

						if (cb) cb();
					} else {
						console.log('上传失败')
						plus.nativeUI.toast('上传失败');
						$scope.$apply(function() {
							$scope.mask = false;
							//上传失败，清除本地现实图片
							$scope.urls.shift();
						})
					}
				});
			task.addFile(url, {
				key: 'Filedata'
			});


			task.start();
			$scope.$apply(function() {
				$scope.mask = true;
			})

			var tas = {
				path: url,
				intask: task
			};
			tasks.push(tas);
		};

		function asycn(list, cb_exec, cb_end) {
			var each = function(_list, cb) {
				if (_list.length < 1) {
					return cb_end && cb_end();
				}
				cb(_list.shift(), function() {
					each(list, cb);
				});
			}
			each(list, cb_exec);
		};


		function isCon(arr, val) {
			for (var i = 0, len = arr.length; i < len; i++) {
				if (arr[i] == val)
					return true;
			}
			return false;
		};


		$window.mui.back = function() {

			plus.webview.close(plus.webview.currentWebview());

			/**
			 * @description back的时候，取消上传任务  http://www.html5plus.org/doc/zh_cn/uploader.html#plus.uploader.Upload.abort
			 */

			for (i in tasks) {
				tasks[i]['intask'].abort()
			}
		}

		$scope.subStart = true;

		$scope.uploaderFunc = function() {

			if ($scope.subStart) {
				$scope.subStart = false;

				if ($scope.comments !== undefined) {
					if ($scope.comments.length < 1) {
						$scope.subStart = true;
						return plus.nativeUI.toast('评论不能为空');
					}

					$scope.mask = true;

					var anonymity = $scope.checkboxModel ? 1 : 0;
					lens = lens ? lens : '';

					if (lens.length > 0) {
						lens = lens.slice(0, lens.length - 1)
						console.log(lens);
					}

					Xmj['获取数据'](Util.Interface['评论'].params(data.User_ID, data.User_TokenStr, comments.Order_ID, comments.Product_ID, $scope.cateId, $scope.comments, anonymity, lens))
						.then(function(data) {
							console.log(data);
							if (data) {
								plus.nativeUI.toast('评论成功');
								userInfo.has_Refresh('true')
								console.log(commentListWebview.id)
								mui.fire(plus.webview.getWebviewById(commentListWebview.id), 'refresh');
								mui.back();
							} else {
								plus.nativeUI.toast('失败');
							}
						}).catch(function() {
							console.log('error');
							plus.nativeUI.toast('请检测网络');
							$scope.$apply(function() {
								$scope.mask = false;
							})
						});


				} else {
					plus.nativeUI.toast('评论不能为空');
					$scope.subStart = true;
				}

			}

		}

		$scope.checkboxModel = true;

		$scope.checkboxFunc = function() {
			$scope.checkboxModel = !$scope.checkboxModel;
		}

		$scope.aboutFunc = function(num) {
			$scope.cateId = num;
		}

	}
])

app.controller('couponDetailCtrl', ['$scope', '$http', '$window', '$interval',
	function($scope, $http, $window, $interval) {
		$window.addEventListener('action',function(event){
			var cid = event.detail.id;
			$scope.$apply(function() {
				$scope.initCouponPage(cid);
			});
		});
		$scope.initCouponPage = function(cid) {
			var data_coupon = plus.storage.getItem('coupon_'+cid);
			if(data_coupon){
				$scope.conponDetail = data_coupon;
				$scope.mask = true;
			}else{
				$http({
					method: 'POST',
					url: Util.WcfUrl + 'GetCouponModel',
					headers: {
						'Content-Type': 'text/json'
					},
					responseType: 'json',
					data: {
						Cid: cid
					}
				}).success(function(data, status, headers, config) {
//					plus.storage.setItem('coupon_'+cid,JSON.stringify(data));
					$scope.conponDetail = data;
					$scope.mask = true;
				}).error(function(data, status, headers, config) {
					tool.notNetworkBack('back');
					console.log('sss');
				});
			}
		};
		$scope.getCoupon = function(id) {
			$http({
				method: 'POST',
				url: Util.WcfUrl + 'GetCouponUser',
				headers: {
					'Content-Type': 'text/json'
				},
				responseType: 'json',
				data: {
					Uid: parseInt(userInfo.uid()),
					token: userInfo.token(),
					Cid: id
				}
			}).success(function(data, status, headers, config) {
				console.log(data);
				//返回数据   0 领取成功  -1 非法请求 1 未登录 2 已经领完
				if (data == 0) {
					mui.toast('领取成功');
				} else if (data < 0) {
					mui.toast('已领取过或数量已发完');
				} else if (data == 1) {
					mui.toast('未登录');
				} else if (data == 2) {
					mui.toast('已经被领完了！');
				}

			}).error(function(data, status, headers, config) {});
		}
		
	}
])



app.controller('findPasswordCtrl', ['$scope', '$http', '$window', '$interval', 'Xmj',
	function($scope, $http, $window, $interval, Xmj) {
		
		var copyBack;
		$scope.valiAccountState = 0;
		
		$scope.changeVakiAccountState = function(index){
			$scope.valiAccountState = index;
		}
		
		$scope.phoneNumber = '';
		
		$scope.phoneValiNumber = '';
		
		$scope.ResetPwdStep1BtnState = true;
		$scope.ResetPwdStep2BtnState = true;
		$scope.ResetPwdStep3BtnState = true;
		
		var q;
		
		$scope.ResetPwdStep3 = function(password,qPassword){
			$scope.ResetPwdStep3BtnState = false;
			
			if (!!!password || password.length < 7) {
				return callback('密码最短为 7个字符');
			}
			if (!!!qPassword || password !== qPassword) {
				return callback('2次密码不一致');
			}
			
			Xmj['获取数据'](Util.Interface['找回密码3'].params({
				Phone : $scope.phoneNumber,
				User_Pass : password,
				User_QueryPass : qPassword
			}))
						.then(function(data) {

							switch(data)
							{
								case -1:
								  	plus.nativeUI.toast('密码错误');
								  	break;
								case -2:
									plus.nativeUI.toast('该手机不存在');
								  	break;
								case -3:
									plus.nativeUI.toast('修改失败');
								  	break;
								case 0:
									plus.nativeUI.toast('修改成功，请重新登录！');
									copyBack();
									$scope.changeVakiAccountState(0);
									break;
								default:
									plus.nativeUI.toast('服务器繁忙，请稍等再试！');
									console.log('err');
								//情况之外	
							}
							$scope.ResetPwdStep3BtnState = true;
							
						}).catch(function() {
							console.log('error');
							plus.nativeUI.toast('请检测网络');
							$scope.ResetPwdStep3BtnState = true;
						});
		}
		
		$scope.againValiText = '重新获取';
		$scope.againValiState = true;
		$scope.againVali = function(){
			$scope.againValiState = false;
			$scope.ResetPwdStep1($scope.phoneNumber);
			$scope.againValiText = 60;
			q = $interval(function(){
				--$scope.againValiText;
				if($scope.againValiText == 0){
					$interval.cancel(q);
					$scope.againValiState = true;
					$scope.againValiText = '重新获取';
				}
			},1000);
			
		}
		$scope.ResetPwdStep2 = function(vali){
			if(!!!vali || !!!vali.length > 0){
				return plus.nativeUI.toast('请输入验证码');
			}
			$scope.ResetPwdStep2BtnState = false;
			Xmj['获取数据'](Util.Interface['找回密码2'].params({
				Phone : $scope.phoneNumber,
				Code : vali
			}))
						.then(function(data) {

							switch(data)
							{
								case -1:
								  	plus.nativeUI.toast('该手机不存在');
								  	break;
								case -2:
									plus.nativeUI.toast('验证码错误');
								  	break;
								case 0:
									plus.nativeUI.toast('验证成功！');
									$scope.changeVakiAccountState(2);
								  	break;
								default:
									plus.nativeUI.toast('服务器繁忙，请稍等再试！');
									console.log('err');
								//情况之外	
							}
							$scope.ResetPwdStep2BtnState = true;
							
						}).catch(function() {
							console.log('error');
							plus.nativeUI.toast('请检测网络');
							$scope.ResetPwdStep2BtnState = true;
						});
		}
		$scope.ResetPwdStep1 = function(phone){
			
			if (!!!phone || !!!phone.toString().match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/)) {
				return plus.nativeUI.toast('请输入确定的手机号码');
			}
			$scope.ResetPwdStep1BtnState = false;
			Xmj['获取数据'](Util.Interface['找回密码1'].params({
				Phone : phone
			}))
						.then(function(data) {
							console.log(data);
							switch(data)
							{
								case -1:
								  	plus.nativeUI.toast('手机格式有错误');
								  	break;
								case -2:
									plus.nativeUI.toast('手机号码不存在');
								  	break;
								case -3:
									plus.nativeUI.toast('短信发送失败');					
								  	break;
								case 0:
									plus.nativeUI.toast('短信已发送');
									$scope.changeVakiAccountState(1);
								  	break;
								default:
									plus.nativeUI.toast('服务器繁忙，请稍等再试！');
									console.log('err');
								//情况之外	
							}
							
							$scope.ResetPwdStep1BtnState = true;
						}).catch(function() {
							console.log('error');
							plus.nativeUI.toast('请检测网络');
							$scope.ResetPwdStep1BtnState = true;
						});
		}
		
		mui.plusReady(function(){
			copyBack = mui.back;
			
			mui.back = function(){
				if($scope.valiAccountState != 0){
					$scope.$apply(function(){
						$scope.valiAccountState = 0;
					})
					return;
				}
				copyBack();
			}
		})
		
		
	}
]);

app.controller('loginCtrl', ['$scope', '$http', '$window', '$interval', 'Xmj',
	function($scope, $http, $window, $interval, Xmj) {

		var stopPlus;

		$scope.username = userInfo.username();
		$scope.password = userInfo.password();
		$scope.regPhone = '';

		$scope.validatePhone = '';

		$scope.BtnState = true;

		$scope.tagObj = true;

		Xmj.PlusReady(10).then(function() {
			//			$scope.oauthArea();
		})


		$scope.auths = {};

		$scope.oauthArea = function() {
			plus.oauth.getServices(function(services) {

				$scope.$apply(function() {
					$scope.iservices = services;
				})

				//根据键值队存储对象

				for (var i in services) {
					var service = services[i];
					$scope.auths[service.id] = service;
				}

			}, function(e) {
				oauthArea.style.display = 'none';
				plus.nativeUI.toast("获取登录认证失败：" + e.message);
			});
		}

		$scope.openOauth = function(authId) {
			var auth = $scope.auths[authId];
			var waiting = plus.nativeUI.showWaiting();
			auth.login(function() {
				waiting.close();
				plus.nativeUI.toast("登录认证成功");

				auth.getUserInfo(function() {
					plus.nativeUI.toast("获取用户信息成功");

					var name = auth.userInfo.nickname || auth.userInfo.name;
					xmjlogin.createState(name, function() {
						//用户名登录
					});
				}, function(e) {
					plus.nativeUI.toast("获取用户信息失败：" + e.message);
				});
			}, function(e) {
				waiting.close();
				plus.nativeUI.toast("登录认证失败：" + e.message);
			});
		}

		$scope.loginFunc = function() {
			$scope.BtnState = false;
			$scope.login(function(err) {
				if (err) {
					plus.nativeUI.toast(err);
					$scope.BtnState = true;
				}
			});
		}

		var backID = null; // 上一页面ID
		$window.addEventListener('openlogin', function(event) {
			backID = event.detail.id;
		});
		$scope.login = function(callback) {
			var callback = callback || function() {};
			if (!!!$scope.username || $scope.username.length < 1) {
				return callback('账号不能为空');
			}
			if (!!!$scope.password || $scope.password.length < 6) {
				return callback('密码最短为 6个字符');
			}
            var cartMainView = null;
			Xmj['获取数据'](Util.Interface['登录'].params($scope.username, $scope.password))
				.then(function(data) {
					if (data !== null) {
						if(data.User_State == 0){
							if(!cartMainView){
								cartMainView = plus.webview.getWebviewById('examples/shoppingCart.html');
								console.log(cartMainView);
							}
							//帐号正常
							console.log('登录成功信息');
							console.log(data);
							window.localStorage.setItem('user', JSON.stringify(data));
							console.log(JSON.parse(localStorage.getItem('user')).User_TokenStr);
							userInfo.settingAccount(data, $scope.username, $scope.password);
							userInfo.has_Refresh('ture');
							
							mui.fire(plus.webview.getWebviewById(backID), 'loginBack');
							mui.fire(cartMainView, 'classifyOpen');
							//plus.webview.currentWebview().hide();
							mui.back();
						}else if(data.User_State == 1){
							//  帐号关闭
							return callback('登录失败,帐号以被关闭');
							
						}else if(data.User_State == -1){
							// 帐号被锁定
							return callback('登录失败,帐号为激活');
						}

					} else {
						return callback('登录失败,请检查账户密码是否正确');
					}

					$scope.BtnState = true;
				}).catch(function() {
					return callback('登录失败,请检查账户密码是否正确');
					$scope.BtnState = true;
				});


		}
		$scope.regFunc = function() {
			$scope.BtnState = false;
			$scope.reg(function(err) {
				if (err) {
					plus.nativeUI.toast(err);
					$scope.BtnState = true;
				}
			});
		}

		$scope.reg = function(callback) {
			var callback = callback || function() {};
			console.log($scope.regUsername);
			
			if (!!!$scope.regPhone || !!!$scope.regPhone.toString().match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/)) {

				return callback('请输入正确的手机号码');
			}
			
//			if (!!!$scope.regUsername || $scope.regUsername.length < 5) {
//				return callback('账号最短为 5 个字符');
//			}
			if (!!!$scope.regPassword || $scope.regPassword.length < 7) {
				return callback('密码最短为 7个字符');
			}
			if (!!!$scope.regPassword || !!!$scope.regPasswordConfirm || $scope.regPassword !== $scope.regPasswordConfirm) {
				return callback('2次密码不一致');
			}

			
			if (!!!$scope.validatePhone || $scope[$scope.regPhone] != $scope.validatePhone) {
				return callback('请输入正确的手机验证码');
			}

			var md5PassWord = md5.encrypt($scope.regPassword + 'xmj');

			Xmj['获取数据'](Util.Interface['注册'].params($scope.regPhone, md5PassWord, $scope.regPhone))
				.then(function(data) {
					if (data !== null) {
						switch (data) {
							case -1:
								plus.nativeUI.toast('注册失败,请稍后在试');
								break;
							case 1:
								plus.nativeUI.toast('用户或手机已存在');
								break;
							case 0:
								plus.nativeUI.toast('注册成功');
								$scope.regUsername = '';
								$scope.regPassword = '';
								$scope.regPasswordConfirm = '';
								$scope.regPhone = '';
								$scope.validatePhone = '';
								$scope.tagObj = true;
								break;
							default:
								plus.nativeUI.toast('注册出问题了，请检查你的网络');
						};


					} else {
						return callback('注册失败,请稍后在试');
					}

					$scope.BtnState = true;
				}).catch(function() {
					return callback('注册失败,请稍后在试');
					$scope.BtnState = true;
				});

		}

		$scope.getPhoneValidateStart = false;
		$scope.getPhoneValidateStart2 = true;
		$scope.getPhoneValidateTimerOut = 60;

		$scope.getPhone = function() {
			console.log($scope.regPhone)
			if ($scope.getPhoneValidateStart2) {
				$scope.getPhoneValidateStart2 = false;
				console.log($scope.regPhone);


				if ($scope.regPhone && !!$scope.regPhone.toString().match(/^(0|86|17951)?(13[0-9]|15[012356789]|17[678]|18[0-9]|14[57])[0-9]{8}$/)) {
					$scope.getPhoneValidateStart = true;
					var validateTimerOut = $interval(function() {
						if ($scope.getPhoneValidateTimerOut === 0) {
							$scope.getPhoneValidateStart = false;
							$scope.getPhoneValidateTimerOut = 60;
							$scope.getPhoneValidateStart2 = true;
							$interval.cancel(validateTimerOut);
						}
						--$scope.getPhoneValidateTimerOut;
					}, 1000)

					Xmj['获取数据'](Util.Interface['短信'].params($scope.regPhone))
						.then(function(data) {
							console.log(data);
							if (typeof data === 'number' && data > 0) {
								//存储手机号码对应的验证码，用来验证用户输入的验证码是否正确
								$scope[$scope.regPhone] = data;
//								$scope.validatePhone = data;
							}else if(data == -1){
								plus.nativeUI.toast('该手机号以注册！');
							}else {
								plus.nativeUI.toast('获取验证码失败,请稍后在尝试');
							}
						}).catch(function() {
							console.log('error');
							plus.nativeUI.toast('获取验证码失败,请稍后在尝试');
						});

				} else {
					$scope.getPhoneValidateStart2 = true;
					plus.nativeUI.toast('请输入正确的手机号码');
				}
			}

		}
	}
]);
//加载更多...
app.directive("directiveScrolleds", function($window) {
	return {
		link: function(scope, elm, attr) {
			var raw = elm[0];
			var ydate = 1;

			angular.element($window).bind('scroll', function() {
				//				console.log(document.body.clientHeight+'--'+document.documentElement.clientHeight+'--'+window.pageYOffset);
				var date = new Date();
				var data = date.getTime();
				if (this.pageYOffset > raw.offsetHeight - $window.innerHeight) {
					if (ydate && (data - ydate) > 2000) {
						scope.$apply(attr.directiveScrolleds);
						ydate = data;
					}

				}
			});
		}

	}
})