var xmj_app = angular.module('mallApp', ['ngTouch', 'services']);

xmj_app.controller('detailsCtrl', ['$scope', '$http', '$window', '$timeout', '$sce','$interval', 'Xmj',
	function($scope, $http, $window,$timeout,$sce,$interval, Xmj) {
		$scope.showImageView = function(imageList,index){
			console.log(imageList)
			console.log(index)
			mui.openWindow({
				url : '../imageviewer.html',
				id : 'imageviewer',
				extras:{
					images : imageList,
					index : index
    			},
    			waiting:{
      				autoShow:true
      			}
			})
		}
		$window.addEventListener('freshendetail', function(event) {
			document.body.scrollTop = 0;
			var id = event.detail.id;
			$scope.favored = false;
			document.getElementById('loadingPage').style.display = 'block';
			$timeout(function() {
					document.getElementById('loadingPage').style.display = 'none';
				}, 500);
			$scope.getCommodityData(id);
			$scope.getComment(id);
		});
		$scope.getCommodityData = function(id) {
			if (plus.storage.getItem('Pid' + id)) {

				$scope.CommodityData = JSON.parse(plus.storage.getItem('Pid' + id));
				console.log('获取的是缓存数据');
				$scope.renderHtml(id);
				$timeout(function() {
					document.getElementById('loadingPage').style.display = 'none';
				}, 500);
			} else {
				var uid = userInfo.uid() ? userInfo.uid() : null;

				Xmj['获取数据'](Util.Interface['产品详情'].params(id, uid))
					.then(function(data) {
						console.log('获取的是请求数据');
					
						plus.storage.setItem('Pid' + id, JSON.stringify(data));
						$scope.CommodityData = data;
						$scope.renderHtml(id);
					}).catch(function(error) {
						console.log(error);
						plus.nativeUI.toast('请检测网络');
						mui.back();
					});
			}
		}
		$scope.getComment = function(pid){
			Xmj['获取数据'](Util.Interface['商品评价列表'].params(pid, 0, 1, 10))
					.then(function(data) {
						console.log('评价列表数据');
						console.log(data);
						$scope.commentList = data;
						$timeout(function() {
							document.getElementById('loadingPage').style.display = 'none';
						}, 500);
					}).catch(function() {
						console.log('error');
					});
		}

		$scope.renderHtml = function(id) {
			$scope.productName = $scope.CommodityData.Product.Product_Name;
			$scope.productDesc = $scope.CommodityData.Product.Product_Desc;
			$scope.productPrice = $scope.CommodityData.Product.Product_Price;
			$scope.productId = $scope.CommodityData.Product.Product_ID;
			$scope.productMarketPrice = $scope.CommodityData.Product.Product_MarketPrice;
			$scope.productPoint = $scope.CommodityData.Product.Product_Point;
			$scope.couponList = $scope.CommodityData.CouponList;
			$scope.goodsDetail = $scope.CommodityData.Product;
			$scope.Product_Details = $scope.CommodityData.Product.Product_Details;
			$scope.Product_Details = $scope.Product_Details.replace(/\/Scripts\//g, Util.ImgCdn + "/Scripts/");
//			$scope.Product_Details = $scope.Product_Details.replace(/src/g, 'class="imglist" data-preview-src="" data-preview-group="1" src');
			$scope.cc = $sce.trustAsHtml($scope.Product_Details);	
		
			if(!userInfo.has_login()){
				$scope.isFavor =  false;
			}else{
				$scope.isFavor = $scope.goodsDetail.FavorProduct_ID ? true: false;
			}
			
			$scope.diyCache(id);

			$scope.bannerHandle();

			$scope.skuFunc();

			$scope.unitPriceFunc();
			
		}


		$scope.diyCache = function(id) {
			$scope.openDiy = $scope.CommodityData.Product.Product_Height;

		}

		$scope.bannerHandle = function() {
			var ProductImgList = $scope.CommodityData.ProductImgList;
				for (var i = 0, len = ProductImgList.length; i < len; i++) {
					ProductImgList[i].ProductImg_Url = Util.ImgCdn + ProductImgList[i].ProductImg_Url;
				}
				$scope.sliderStartImg = ProductImgList[ProductImgList.length - 1].ProductImg_Url;
				$scope.sliderEndImg = ProductImgList[0].ProductImg_Url;
				$scope.sliderListImg = ProductImgList;
					var gallery = mui('.mui-slider');
						gallery.slider({
						'slideshowDelay': 0,
						interval: 5000
					});
		}

		/**
		 *  @description SKU选择
		 */

		$scope.skuFunc = function() {
			$scope.skus = $scope.CommodityData.GroupAndAttrsList;
			$scope.stockSku = $scope.CommodityData.ProductListSku;

			$scope.goodSku = {};
			var flag = 0;
			var k = 0;
			var myType = function(x, y) {
				this.skuTypeName = x;
				this.skuTypeId = y;
			}
			for (var i = 0; i < $scope.skus.length; i++) {
				if (flag != $scope.skus[i].ProductSkuGroup_Name) {
					$scope.goodSku[k] = new myType($scope.skus[i].ProductSkuGroup_Name, $scope.skus[i].ProductSkuGroup_ID);
					flag = $scope.skus[i].ProductSkuGroup_Name;
					k++;
				}

			}

			var grounpId = function(a, b) {
				this.cid = a;
				this.tid = b;
			}
			var flagid = [];
			var flagtid = [];
			var skuprocee = function(cid) {
				var selectPosition;
				for (var i = 0; i < $scope.skus.length; i++) {
					if ($scope.skus[i].ProductSkuAttrs_ID == cid) {
						selectPosition = i;
						return selectPosition;
						break;
					}
				}
			}

			// 默认选择第一个
			if (k == 1) {
				$scope.goodSku[0].selected = $scope.skus[0].ProductSkuAttrs_Name;
				$scope.productSku_Stock = $scope.stockSku[0].ProductSku_Stock;
				$scope.productPrice = $scope.stockSku[0].ProductSku_Price;
				$scope.productMarketPrice = $scope.stockSku[0].ProductSku_MarketPrice;
				$scope.skuid = $scope.stockSku[0].ProductSkuAttrs_IDS;
			}
			// 点击选择SKU
			$scope.curSku = function(id, tid, index) {
				//判断点击的第一行还是第二行sku
				var isSelectTid = $scope.skus[0].ProductSkuGroup_ID == tid ? true : false;
				// 单组SKU
				if (k == 1) {
					$scope.goodSku[0].selected = $scope.skus[index].ProductSkuAttrs_Name;
					$scope.skuid = id;
					for (var i = 0; i < $scope.stockSku.length; i++) {
						if ($scope.stockSku[i].ProductSkuAttrs_IDS == id) {
							$scope.productSku_Stock = $scope.stockSku[i].ProductSku_Stock;
							$scope.productPrice = $scope.stockSku[i].ProductSku_Price;
							$scope.productMarketPrice = $scope.stockSku[i].ProductSku_MarketPrice;
							$scope.skuid = $scope.stockSku[i].ProductSkuAttrs_IDS;
							break;
						}
					}
					//								$scope.skuid = $scope.skuid.join('');
				} else if (k == 2) { // 多组SKU		
					if (flagid == '' && flagtid == '') {
						flagid[0] = id;
						flagtid[0] = tid;
						var o = skuprocee(flagid);
						if (isSelectTid) {
							$scope.goodSku[0].selected = $scope.skus[o].ProductSkuAttrs_Name;
						} else {
							$scope.goodSku[1].selected = $scope.skus[o].ProductSkuAttrs_Name;
						}

						//首次选择sku

					} else if (flagid[0] != id && flagtid[0] == tid) {

						// 继续选择属性一
						flagid[0] = id;
						var o = skuprocee(flagid[0]);
						if (isSelectTid) {
							$scope.goodSku[0].selected = $scope.skus[o].ProductSkuAttrs_Name;
						} else {
							$scope.goodSku[1].selected = $scope.skus[o].ProductSkuAttrs_Name;
						}
					}
					//								else if(flagid == id && flagtid == tid){
					//									alert('3');
					//									// 反选
					//									flagid = 0;
					//									flagtid = 0;
					//									var o = 	skuprocee(flagid);
					//									$scope.selected[0]= '';
					//								} 
					else if (flagtid[0] != 0 && flagtid[0] != tid) {
						// 选择属性二
						flagid[1] = id;
						flagtid[1] = tid;
						$scope.skuid = flagid.join(',');
						console.log($scope.skuid);
						var o = skuprocee(flagid[1]);
						if (isSelectTid) {
							$scope.goodSku[0].selected = $scope.skus[o].ProductSkuAttrs_Name;
						} else {
							$scope.goodSku[1].selected = $scope.skus[o].ProductSkuAttrs_Name;
						}

					}

					for (var i = 0; i < $scope.stockSku.length; i++) {
						if ($scope.stockSku[i].ProductSkuAttrs_IDS == flagid) {
							$scope.productSku_Stock = $scope.stockSku[i].ProductSku_Stock;
							$scope.productPrice = $scope.stockSku[i].ProductSku_Price;
							$scope.productMarketPrice = $scope.stockSku[i].ProductSku_MarketPrice;
							break;
						} else {
							$scope.productSku_Stock = 0;
						}
					}
				}

			}

			$scope.loadingReady = true;
		}

		/**
		 *  @description  单选
		 */

		$scope.unitPriceFunc = function() {
			$scope.unitPrice = $scope.CommodityData.Product.Product_Price;

			var unitPrice = parseInt($scope.unitPrice);

			// 初始化 carts.num 值
			 $scope.cartsnums = 1;
			$scope.goodsDetail.Product_LowestCount = $scope.goodsDetail.Product_LowestCount != 0 ? $scope.goodsDetail.Product_LowestCount : 1;
//			$scope.cartsnums = $scope.goodsDetail.Product_LowestCount ? $scope.goodsDetail.Product_LowestCount : 1;
			$scope.changeCount = function(type) {
				var count = parseInt($scope.cartsnums);
				if (type == 'add') {
					count++;
				} else {
					count--;
				}
				if (count < 1) {
					count = 1;
				}
				if (count > $scope.productSku_Stock) {
					count = $scope.productSku_Stock;
					mui.toast('您所填写的宝贝数量超过库存！');
				} else if (count <1) {
					count = 1;

				}
				$scope.cartsnums = count;
			};
		}



		$scope.openCoupon = function(id) {


			if (userInfo.has_login()) {
				mui.openWindow({
					url: 'couponDetail.html',
					id: 'couponDetail',
					styles: {
						top: '0',
						bottom: '0'
					},
					show: {
						duration: 200
					},
					extras: {
						cid: id
					}

				});
				mui.fire(plus.webview.getWebviewById('couponDetail'), 'couponinfo', {
					id: id
				});
			} else {
				userInfo.openLogin(plus.webview.currentWebview().id);

			}

		}


		$scope.share = function() {
//			alert('分享');
		}

		$scope.collect = function(id) {

			if (userInfo.has_login()) {
				console.log(userInfo.uid() + '--' + userInfo.token() + '--' + id)

				Xmj['获取数据'](Util.Interface['加入收藏'].params(userInfo.uid(), userInfo.token(), id))
					.then(function(data) {
						if (data == true) {
							$scope.favored = true;
							mui.toast('收藏成功！');
							//更新存储数据
							Xmj['获取数据'](Util.Interface['产品详情'].params(id, userInfo.uid()))
								.then(function(data) {
									plus.storage.setItem('Pid' + id, JSON.stringify(data));
								}).catch(function() {
									console.log('error');
								});

						} else {
							mui.toast('已收藏');
						}
					}).catch(function() {
						console.log('error');
						mui.toast('网络超时或未登录！');
					});
			} else {
				userInfo.openLogin(plus.webview.currentWebview().id);
			}

		}
		// 
		$scope.blurs = function(){
			var num = parseInt($scope.cartsnums);
			if (isNaN(num)) {
				$scope.cartsnums = 1;
			} else {
				if(num > $scope.goodsDetail.Product_Stock){
					$scope.cartsnums = $scope.goodsDetail.Product_Stock;
				}else if(num < 1){
					$scope.cartsnums = 1;
				}
				else{
					$scope.cartsnums = num;
				}
			}
		};
		$scope.cartpage = function() {
			plus.webview.getWebviewById('examples/cart_main.html').show('pop-in',200);
		}
		$scope.openComment = function(id){
//			alert(id);
			if($scope.commentList.length > 2){
				var 	 details2WebView = plus.webview.getWebviewById('details2.html');
				// 触发详情页ID
				mui.fire(details2WebView, 'freshendetails2', {
					id: id
				});
				//显示新闻详情页面
				details2WebView.show('pop-in', 200);
			}
		}
		
		$scope.Province = $scope.Province ? $scope.Province : '广东省';
		
		function cartSizeFunc(){
			$http({
				method: 'POST',
				url: Util.WcfUrl + 'GetCartList',
				headers: {
					'Content-Type': 'text/json'
				},
				responseType: 'json',
				data: {
					Uid: userInfo.uid(),
					token: userInfo.token(),
					Province: $scope.Province
				},
				timeout: 5000,
			}).success(function(data, status, headers, config) {
				//有时候返回的不是数组 所以会报错
				var LaunchWebview = plus.webview.getLaunchWebview();
				if(data.length){
					mui.fire(LaunchWebview, 'cartSize', {len: data.length});
				}else{
					mui.fire(LaunchWebview, 'cartSize', {len: 0});
				}
			}).error(function(data, status, headers, config) {
				if(!userInfo.has_login()){
					mui.toast('未登录');
				}else{
					mui.toast('网络超时');
				}
				$scope.cartErrow = true;
			});
		}
		
		$scope.joinShopping = function() {


			if (userInfo.has_login()) {

				if ($scope.goodsDetail.Product_DiyID > 0) {
					mui.toast('该类产品请在PC端完成定制下单！');

					return false;
				} else if ($scope.skuid == '' || $scope.skuid == undefined) {
					mui.toast('请选择商品属性！');

					return false;
				} else if ($scope.productSku_Stock == 0) {
					mui.toast('您选择的商品库存为O，请重新选择其他属性商品！');

					return false;
				} else {
					var nums = parseInt($scope.cartsnums);
					if($scope.cartsnums > $scope.goodsDetail.Product_Stock){
						// 数量大于库存时
						$scope.cartsnums = $scope.goodsDetail.Product_Stock;
					}else if(isNaN(nums)){
						// 非法字符
						$scope.cartsnums = $scope.goodsDetail.Product_LowestCount;
					}else{
						// good man
						$scope.cartsnums = $scope.cartsnums;
					}
					
					$http({
						method: 'post',
						url: Util.WcfUrl + 'AddCart',
						headers: {
							'Content-Type': 'text/json'
						},
						responseType: 'json',
						data: {
							Uid: userInfo.uid(),
							token: userInfo.token(),
							Pid: $scope.goodsDetail.Product_ID,
							CategoryId: $scope.goodsDetail.Category_ID,
							number: $scope.cartsnums,
							Skus: $scope.skuid + ''
						}
					}).success(function(data, status, headers, config) {

						mui.toast('已成功加入购物车！');
						$window.localStorage.setItem('cartRefresh', true);
						cartSizeFunc();

					}).error(function(data, status, headers, config) {
						mui.toast('加入购物车失败！');

					})

				}
			} else {
				userInfo.openLogin(plus.webview.currentWebview().id);

			}

		}





	}
])
	// 图片cdn
	.filter('upImg', function() {
		return function(url) {
			var cdnUrl = Util.upUrl + url;
			return cdnUrl;
		}
	})
	//过滤隐藏用户名
	.filter('ellipsis', function() {
		return function(text) {

			var lastStr = text.substr(text.length - 1, 1);
			return text.substr(0, 1) + "**" + lastStr;

		}
	})