var app = angular.module('mallApp', ['ngTouch']);
app.controller('addressCtrl', function($scope, $http, $window) {

	$scope.initAddressList = function() {
		$http({
			method: 'POST',
			url: Util.WcfUrl + 'GetUserAddressList',
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				Uid: userInfo.uid(),
				token: userInfo.token(),
				top: 0
			}
		}).success(function(data, status, headers, config) {
			$scope.addressList = data;
			if (data) {
				$scope.addressList.area = [];
				// 拼接完整省份市区地址
				for (var i = 0; i < $scope.addressList.length; i++) {
					$scope.addressList.area[i] = area_array[$scope.addressList[i].UserAddress_Province] + sub_array[$scope.addressList[i].UserAddress_Province][$scope.addressList[i].UserAddress_City] + ($scope.addressList[i].UserAddress_District == '0' ? '' : sub_arr[$scope.addressList[i].UserAddress_City][$scope.addressList[i].UserAddress_District]);
				}
				$scope.loading = true;
				console.log('---'+$scope.addressList);
			} else {
				alert('网络出错！');
				mui.back();
			}

		});

	}
	$scope.initAddressList();
	// 删除地址
	mui('#addressList').on('tap', 'a.deladdress', function(event) {
			event.stopPropagation();
			var addressID = this.getAttribute('id');
			plus.nativeUI.confirm("是否删除该条记录?", function(e) {
				if (e.index == 0) {
					$http({
						method: 'POST',
						url: Util.WcfUrl + 'DelUserAddress',
						headers: {
							'Content-Type': 'text/json'
						},
						responseType: 'json',
						data: {
							Uid: userInfo.uid(),
							token: userInfo.token(),
							Uaid: addressID
						}
					}).success(function(data, status, headers, config) {
						if (data) {
							$scope.initAddressList();
						} else {
							mui.toast('系统错误或网络问题，请重试！');
						}
					}).error(function(data, status, headers, config) {

					});
				}
			}, "信息提示", ["确定", "取消"]);
		})
		// 添加新地址
	$scope.addAddress = function() {
			if (!$scope.addressList) {
				console.log('没有地址')
				return;
			}
			if ($scope.addressList.length >= 20) {
				plus.nativeUI.alert('地址列表最多保存20条,请删除或者编辑修改', function() {

				}, '警告', '确定');
				return;
			}

			mui.openWindow({
				url: 'addAddress.html',
				id: 'addAddress',
				styles: {
					top: '0',
					bottom: '0'
				},
				show: {
					aniShow: 'pop-in'
				},
				waiting: {
					autoShow: false
				}

			});

		}
		// 编辑地址
	$scope.editpage = true;
	mui('#addressList').on('tap', 'a.editaddress', function() {
		var cid = this.getAttribute('data-id');
		mui.openWindow({
			url: 'editaddress2.html',
			id: 'editAddress',
			styles: {
				top: '0',
				bottom: '0'
			},
			show: {
				aniShow: 'pop-in'
			},
			waiting: {
				autoShow: false
			},
			extras:{
				cid : cid
    		}
		});
	});
	// 设置默认地址
	$scope.defaultAddress = function(addresslist) {
		var pageType = window.localStorage.getItem('pageType');
		console.log('****'+JSON.stringify(addresslist));
		var newProvince = addresslist.UserAddress_Province;
		console.log(area_array[newProvince]);
		$http({
			method: 'POST',
			url: Util.WcfUrl + 'AddressSetDefault',
			headers: {
				'Content-Type': 'text/json'
			},
			responseType: 'json',
			data: {
				Uid: userInfo.uid(),
				token: userInfo.token(),
				Uaid: addresslist.UserAddress_ID
			}
		}).success(function(data, status, headers, config) {
			if (data) {
				$scope.initAddressList();
				if (pageType == 'settlementBack') {
					//返回上一级，并刷新
					mui.fire(plus.webview.getWebviewById('myFuncSubs'), 'settlementRefresh',{province: area_array[newProvince]});
					mui.back();
				}
			} else {
				mui.toast('系统错误或网络问题，请重试！');
			}
		}).error(function(data, status, headers, config) {

		});
	}
	$window.addEventListener('editdone', function() {
		$scope.$apply(function() {
			$scope.initAddressList()
		})

	})
})
app.controller('addAddressCtrl', function($scope, $http, $window) {
	
	mui.plusReady(function() {
		$scope.addressId = tool.getPid();
		$scope.addressId == '' ? $scope.addressId = 0 : $scope.addressId;
	
		$scope.formdata = {};
		$scope.Province = area_array;
		$scope.prov = {};
		$scope.City = {};
		$scope.District = {};
		var myType = function(x, y) {
			this.id = x;
			this.name = y;
		}
		for (var i = 0; i < $scope.Province.length; i++) {
			if ($scope.Province[i] != undefined) {
				$scope.prov[i] = new myType(i, $scope.Province[i]);
			}
		}
		// 选择省份2
		$scope.isActive = false;
		$scope.showProvince = true;
		//弹出省份选择框
		$scope.selectArea = function() {
			$scope.isActive = true;
			$scope.showProvince = true;
			$scope.showCity = false;
			$scope.showDistrict = false;
			$scope.formdata.provinceName1 = '';
			$scope.formdata.cityName1 = '';
			$scope.formdata.districtName1 = '';
		}
		$scope.closeAreaPanel = function() {
			$scope.isActive = false;
		}
		$scope.selectP = function(value) {
			if(value.name == '请选择省份'){
					return;
				}
			$scope.showProvince = false;
			$scope.showCity = true;
			$scope.city = sub_array[value.id];
			$scope.City = {};
			$scope.District = {};
			for (var i = 0; i < $scope.city.length; i++) {
				if ($scope.city[i] != undefined) {
					$scope.City[i] = new myType(i, $scope.city[i]);
				}
			}
			//临时性记录和显示id和name
			$scope.formdata.provinceName1 = value.name;
			$scope.formdata.provinceId1 = value.id;
		}
		$scope.selectC = function(value) {
			if(value.name == '请选择'){
					return;
				}
			$scope.showCity = false;
			$scope.showDistrict = true;
			$scope.District = {};
			$scope.district = sub_arr[value.id];
			$scope.formdata.cityName1 = value.name;
			$scope.formdata.cityId1 = value.id;
			if ($scope.district) {
				for (var i = 0; i < $scope.district.length; i++) {
					if ($scope.district[i] != undefined) {
						$scope.District[i] = new myType(i, $scope.district[i]);
					}
				}
	
			} else { //直辖市 只需要二级
				$scope.isActive = false;
				$scope.formdata.districtName = '';
				$scope.formdata.districtId = '';
	
				// 转移到输入面板
				$scope.formdata.provinceName = $scope.formdata.provinceName1;
				$scope.formdata.provinceId = $scope.formdata.provinceId1;
				$scope.formdata.cityName = $scope.formdata.cityName1;
				$scope.formdata.cityId = $scope.formdata.cityId1;
			}
	
		}
		$scope.selectD = function(value) {
			
			$scope.isActive = false;
			$scope.formdata.districtName1 = value.name;
			$scope.formdata.districtId1 = value.id;
			// 转移到输入面板
			$scope.formdata.provinceName = $scope.formdata.provinceName1;
			$scope.formdata.provinceId = $scope.formdata.provinceId1;
			$scope.formdata.cityName = $scope.formdata.cityName1;
			$scope.formdata.cityId = $scope.formdata.cityId1;
			$scope.formdata.districtName = $scope.formdata.districtName1;
			$scope.formdata.districtId = $scope.formdata.districtId1;
		}
		
		var oldBack = mui.back;
			
			mui.back = function(){
				if($scope.isActive){
					$scope.$apply(function(){
						$scope.isActive = false;
						$scope.showCity = false;
						$scope.showDistrict = false;
						$scope.showProvince = false;
					})
				}else{
					oldBack();
				}
			}
	
	
		$scope.formdata.isdefault = 0;
		$scope.saveAddress = function() {
			if (!$scope.formdata || !$scope.formdata.username || $scope.formdata.username.length <= 0) {
				mui.toast('请填写联系人姓名! ');
				return false;
			}
	
			if (!Util.isPhoneNum($scope.formdata.tel)) {
				mui.toast('电话号码格式不正确！');
				return false;
			}
			if (!$scope.formdata.provinceId || !$scope.formdata.cityId) {
				mui.toast('请填写所在地址！');
				return false;
			}
			if (!$scope.formdata || !$scope.formdata.address || $scope.formdata.address.length <= 0) {
				mui.toast('请填写详细地址! ');
				return false;
			}
	//		if (!Util.isZipCode($scope.formdata.ucode)) {
	//			mui.toast('邮政编码格式不正确！');
	//			return false;
	//		}
	
	
			$scope.isDisabled = true;
			$http({
				method: 'POST',
				url: Util.WcfUrl + 'EditAddress',
				headers: {
					'Content-Type': 'text/json'
				},
				responseType: 'json',
				data: {
					UserAddress_ID: $scope.addressId,
					token: userInfo.token(),
					User_ID: userInfo.uid() + '',
					User_Name: $scope.formdata.username,
					UserAddress_Province: parseInt($scope.formdata.provinceId),
					UserAddress_City: parseInt($scope.formdata.cityId),
					UserAddress_District: $scope.formdata.districtId ? parseInt($scope.formdata.districtId) : 0,
					UserAddress_Address: $scope.formdata.address,
					UserAddress_Phone: $scope.formdata.tel + '',
					UserAddress_Code: $scope.formdata.ucode ? parseInt($scope.formdata.ucode) + '' : 0,
					UserAddress_IsDefault: $scope.formdata.isdefault
				}
			}).success(function(data, status, headers, config) {
				console.log(data);
				if (data == true) {
					mui.toast('添加成功！');
					setTimeout(function() {
						//返回上一级，并刷新
						mui.fire(plus.webview.getWebviewById('address.html'), 'editdone');
						mui.back();
					}, 1000)
				}
			}).error(function(data, status, headers, config) {
				if (data == null) {
					$scope.isDisabled = false;
					mui.toast('请务必填写正确地址！');
				}
			});
	
		}
	})
})
app.controller('editAddressCtrl', ['$scope', '$http', '$window',
	function($scope, $http, $window) {
		
		mui.plusReady(function() {
			plus.webview.currentWebview().setStyle({
				'popGesture': 'close'
			});
			var topoffset = '48px';
            if(plus.navigator.isImmersedStatusbar()){
				// 获取状态栏高度并根据业务需求处理，这里重新计算了子窗口的偏移位置
				topoffset=(Math.round(plus.navigator.getStatusbarHeight())+48)+'px'; 
				document.getElementById('heads').style.paddingTop = Math.round(plus.navigator.getStatusbarHeight())+ 'px';
			}
            document.body.style.paddingTop = topoffset;
            document.getElementById('loadingPage').style.top = topoffset;
            

            $scope.addressId = plus.webview.currentWebview().cid;
            $http({
				method: 'POST',
				url: Util.WcfUrl + 'GetUserAddress',
				headers: {
					'Content-Type': 'text/json'
				},
				responseType: 'json',
				data: {
	
					token: userInfo.token(),
					Uid: userInfo.uid(),
					Aid: $scope.addressId
				},
				timeout: 5000
			}).success(function(data, status, headers, config) {
				$scope.loading = true;
				$scope.formdata = data;
				$scope.formdata.UserAddress_Phone = parseInt($scope.formdata.UserAddress_Phone);
				console.log(data);
				$scope.formdata.UserAddress_Code = $scope.formdata.UserAddress_Code == 0 ? '' : $scope.formdata.UserAddress_Code;
				// 省份ID转中文
				$scope.formdata.provinceName = area_array[$scope.formdata.UserAddress_Province];
				$scope.formdata.provinceId = $scope.formdata.UserAddress_Province;
				$scope.formdata.cityName = sub_array[$scope.formdata.UserAddress_Province][$scope.formdata.UserAddress_City];
				$scope.formdata.cityId = $scope.formdata.UserAddress_City;
				$scope.formdata.districtName = ($scope.formdata.UserAddress_District == 0 ? '' : sub_arr[$scope.formdata.UserAddress_City][$scope.formdata.UserAddress_District]);
				$scope.formdata.districtId = $scope.formdata.UserAddress_District;
			}).error(function(data, status, headers, config) {
				mui.toast('网络异常');
				mui.back();
			});
			
			
			$scope.Province = area_array;
			$scope.prov = {};
			$scope.City = {};
			$scope.District = {};
			var myType = function(x, y) {
					this.id = x;
					this.name = y;
				}
				// 加载省份
			for (var i = 0; i < $scope.Province.length; i++) {
				if ($scope.Province[i] != undefined) {
					$scope.prov[i] = new myType(i, $scope.Province[i]);
				}
			}
			$scope.isActive = false;
			$scope.showProvince = true;
			//弹出省份选择框
			$scope.selectArea = function() {
				$scope.isActive = true;
				$scope.showProvince = true;
				$scope.showCity = false;
				$scope.showDistrict = false;
				$scope.formdata.provinceName1 = '';
				$scope.formdata.cityName1 = '';
				$scope.formdata.districtName1 = '';
			}
			$scope.closeAreaPanel = function() {
				$scope.isActive = false;
			}
			$scope.selectP = function(value) {
				if(value.name == '请选择省份'){
					return;
				}
				$scope.showProvince = false;
				$scope.showCity = true;
				$scope.city = sub_array[value.id];
				$scope.City = {};
				$scope.District = {};
				for (var i = 0; i < $scope.city.length; i++) {
					if ($scope.city[i] != undefined) {
						$scope.City[i] = new myType(i, $scope.city[i]);
					}
				}
				//临时性记录和显示id和name
				$scope.formdata.provinceName1 = value.name;
				$scope.formdata.provinceId1 = value.id;
			}
			$scope.selectC = function(value) {
				if(value.name == '请选择'){
					return;
				}
				$scope.showCity = false;
				$scope.showDistrict = true;
				$scope.District = {};
				$scope.district = sub_arr[value.id];
				$scope.formdata.cityName1 = value.name;
				$scope.formdata.cityId1 = value.id;
				if ($scope.district) {
					for (var i = 0; i < $scope.district.length; i++) {
						if ($scope.district[i] != undefined) {
							$scope.District[i] = new myType(i, $scope.district[i]);
						}
					}
	
				} else { //直辖市 只需要二级
					$scope.isActive = false;
					$scope.formdata.districtName = '';
					$scope.formdata.districtId = '';
	
					// 转移到输入面板
					$scope.formdata.provinceName = $scope.formdata.provinceName1;
					$scope.formdata.provinceId = $scope.formdata.provinceId1;
					$scope.formdata.cityName = $scope.formdata.cityName1;
					$scope.formdata.cityId = $scope.formdata.cityId1;
				}
	
			}
			$scope.selectD = function(value) {
				
				$scope.isActive = false;
				$scope.formdata.districtName1 = value.name;
				$scope.formdata.districtId1 = value.id;
				// 转移到输入面板
				$scope.formdata.provinceName = $scope.formdata.provinceName1;
				$scope.formdata.provinceId = $scope.formdata.provinceId1;
				$scope.formdata.cityName = $scope.formdata.cityName1;
				$scope.formdata.cityId = $scope.formdata.cityId1;
				$scope.formdata.districtName = $scope.formdata.districtName1;
				$scope.formdata.districtId = $scope.formdata.districtId1;
			}
			
			var oldBack = mui.back;
			
			mui.back = function(){
				if($scope.isActive){
					$scope.$apply(function(){
						$scope.isActive = false;
						$scope.showCity = false;
						$scope.showDistrict = false;
						$scope.showProvince = false;
					})
				}else{
					oldBack();
				}
			}
	
			// 保存
			$scope.saveAddress = function() {
				if (!$scope.formdata || !$scope.formdata.User_Name || $scope.formdata.User_Name.length <= 0) {
					mui.toast('请填写联系人姓名! ');
					return false;
				}
	
				if (!Util.isPhoneNum($scope.formdata.UserAddress_Phone)) {
					mui.toast('电话号码格式不正确！');
					return false;
				}
				if (!$scope.formdata.provinceId || !$scope.formdata.cityId) {
					mui.toast('请填写所在地址！');
					return false;
				}
				if (!$scope.formdata || !$scope.formdata.UserAddress_Address || $scope.formdata.UserAddress_Address.length <= 0) {
					mui.toast('请填写详细地址! ');
					return false;
				}
				$scope.isDisabled = true;
				$http({
					method: 'POST',
					url: Util.WcfUrl + 'EditAddress',
					headers: {
						'Content-Type': 'text/json'
					},
					responseType: 'json',
					data: {
						UserAddress_ID: $scope.addressId,
						token: userInfo.token(),
						User_ID: userInfo.uid() + '',
						User_Name: $scope.formdata.User_Name,
						UserAddress_Province: parseInt($scope.formdata.provinceId),
						UserAddress_City: parseInt($scope.formdata.cityId),
						UserAddress_District: $scope.formdata.districtId ? parseInt($scope.formdata.districtId) : 0,
						UserAddress_Address: $scope.formdata.UserAddress_Address,
						UserAddress_Phone: $scope.formdata.UserAddress_Phone + '',
	//					UserAddress_Code: $scope.formdata.UserAddress_Code ? parseInt($scope.formdata.UserAddress_Code) + '' : 0,
						UserAddress_IsDefault: $scope.formdata.UserAddress_IsDefault
					}
				}).success(function(data, status, headers, config) {
					console.log(data);
					if (data == true) {
						var pid = 'address';
						mui.toast('修改成功！');
						setTimeout(function() {
							//返回上一级，并刷新
							mui.fire(plus.webview.getWebviewById('address.html'), 'editdone');
							mui.back();
						}, 500)
					}
				}).error(function(data, status, headers, config) {
					if (data == null) {
						mui.toast('请务必填写完整的收货地址！');
					}
				});
	
			}
			
			
		});
		
		 
		
		
	}
])