/**
 * @description 添加 获取删除   账户/密码/token/信息
 * 	添加user.username(data)
 * 	获取user.username()
 * 	删除user.username('')
 */

(function(win, user) {

	//重新启动app清除 token
	user.clearToken = function() {
			win.localStorage.removeItem('user');
		}
		// 设置账户信息，账户信息包含 用户名，密码，与当前token	
	user.settingAccount = function(data, user, pwd) {
			win.localStorage.setItem('account_key', user + '|' + pwd + '|' + data.User_TokenStr);
		}
		//退出登录 清除登录信息
	user.clear = function() {
		win.localStorage.removeItem('user');
		localStorage.setItem('cartRefresh', true);
		// 同时删除帐号信息中的token
		var account = localStorage.getItem('account_key');
		var acc = account.split('|');
		acc.pop();
		var akey = acc.join('|');
		localStorage.setItem('account_key', akey);
	}

	//检查是否包含自动登录的信息
	user.auto_login = function() {
			var account = localStorage.getItem('account_key');
			if (account) {
				var acc = account.split('|');
				if (acc.length == 3) {
					return true;
				} else {
					return false;
				}
			}
			return false;
		}
		/**
		 * @description 判断是否登录
		 */
	user.has_login = function() {
		var account = localStorage.getItem('account_key');
		var users = localStorage.getItem('user');
		if (account && users) {
			return true;
		} else {
			return false;
		}
	};

	user.username = function() {
		if (localStorage.getItem('account_key')) {
			var acc = win.localStorage.getItem('account_key').split('|');
			return acc[0];
		} else {
			return null;
		}

	};

	user.password = function() {
		if (localStorage.getItem('account_key')) {
			var acc = win.localStorage.getItem('account_key').split('|');
			return acc[1];
		} else {
			return null;
		}
	};

	user.token = function() {
		if (win.localStorage.getItem('user')) {
			return JSON.parse(win.localStorage.getItem('user')).User_TokenStr;
		}
	};
	user.uid = function() {
		if (win.localStorage.getItem('user')) {
			return JSON.parse(win.localStorage.getItem('user')).User_ID;
		} else {
			return null;
		}
	};

	user.info = function() {
		if (arguments.length == 0) {
			return plus.storage.getItem('userInfo');
		}
		if (arguments[0] === '') {
			plus.storage.removeItem('userInfo');
			return;
		}

		plus.storage.setItem('userInfo', arguments[0]);
	}

	user.search_Record = function() {
		if (arguments.length == 0) {
			return win.localStorage.getItem('search');
		}
		if (arguments[0] === '') {
			win.localStorage.removeItem('search');
			return;
		}
		win.localStorage.setItem('search', arguments[0]);
	}

	user.has_Refresh = function() {
		if (arguments.length == 0) {
			return plus.storage.getItem('refresh');
		}
		if (arguments[0] === '') {
			plus.storage.removeItem('refresh');
			return;
		}

		plus.storage.setItem('refresh', arguments[0]);
	}

	/**
	 * @description 打开登录界面
	 */

	user.openLogin = function(backId) {

		var loginWebView = plus.webview.getWebviewById('examples/ucenter/login.html');
		if (!loginWebView) {
			loginWebView = mui.preload({
				id: 'examples/ucenter/login.html',
				url: '/examples/ucenter/login.html',
				styles: {
					top: '0px',
					bottom: '0px'
				}
			});
			loginWebView.hide();
			console.log('没有加载视图')
		}
		loginWebView.show('slide-in-bottom', 200);
		mui.fire(loginWebView, 'openlogin', {
			id: backId
		});
	}


})(window, window.userInfo = window.userInfo || {});